///////////////////////////////////////////////////////////////////
// The Init function is called when bric is first selected       //
// Use it to make changes to the initial state of the sidebar UI //
///////////////////////////////////////////////////////////////////


function init(bricVersion)
{
	window.webkit.messageHandlers.debug.postMessage("Current Bric Version = "+bricVersion);
}



// Set JS Custom value
function setCustomJSData(customVal,targetAttr)
{
	// Please note: This method is for example purposes, applying JS variable directly into a file using storeCustomBricTemplateVal is wasteful. We recommend using html data attributes
	// to feed variables to JS functions as it makes them more flexible. The storeCustomBricTemplateVal API call is probably better suited to writing variables into PHP and JSON files, however 
	// I couldn't come up with a good example at the time using those languages so I made this just to show how it all works. sorry :)
	
	
	// attr           : The attribute value is used to identify the areas that will be replaced in the template file upon export. When this attribute is used within a template file, it should be wrapped in % e.g. %my-attr%
	// value          : The value that will replace the attribute in the template file.
	// template       : The template file name. This file should be located in a directory named templates within your Brics contents.
	// force-newfile  : If two Brics with different values write to the same template file and this is set to YES, another template file will be created e.g custom-bric-js-1.js.
	
	
	
	window.webkit.messageHandlers.storeCustomBricTemplateVal.postMessage('{"attr":"'+targetAttr+'", "value":"'+customVal+'", "template":"custom-bric-js.js", "force-newfile":"no"}');
}

