
function applyParallaxEffects()
{
	$('.parallax-zoom-blur').each(function(i)
	{
		if($(window).width() > 790) // Desktop Only
		{
			var scrollVal = $(window).scrollTop() - $(this).offset().top + ($(this).outerHeight()/100);
			var scrollValFade = $(window).scrollTop() - $(this).offset().top - ($(this).outerHeight()/3);
			var offSetVal = (scrollVal/10);			
			
			var widthVal = '100%';
			var topVal = '0%';
			var leftVal = '0%';
			var opacity = 1;
			
			if((100 + scrollVal/5) > 100)
			{
				widthVal = (100 +scrollVal/5)+"%";
				topVal = - offSetVal+"%";
				leftVal = - offSetVal+"%";
				opacity = 1.8 - (scrollValFade/250);
			}
			
			$(this).css({ width: widthVal, top: topVal, left: leftVal,'opacity':opacity});
		}
	});
}


function scrollFXObjs()
{
	// scroll-fx-up-in scroll-fx-down-in scroll-fx-left-in scroll-fx-right-in scroll-fx-up-fadein scroll-fx-down-fadein scroll-fx-left-fadein scroll-fx-right-fadein
	$('[class*="scroll-fx-up-"], [class*="scroll-fx-down-"], [class*="scroll-fx-left-"], [class*="scroll-fx-right-"], [class*="scroll-fx-fadein"]').each(function(i)
	{
		if($(window).width() > 790) // Desktop Only
		{
			var centerPoint = ($(window).height()/2)-($(this).outerHeight()/2);
			var exitPoint = ($(window).height()/2)-$(this).outerHeight();
			var scrollVal = $(window).scrollTop() - $(this).offset().top + ($(this).outerHeight()/100)+centerPoint;
			var scrollValFade = $(window).scrollTop() - $(this).offset().top - ($(this).outerHeight()/3);
			var offSetVal = (scrollVal/10);		

			leftVal = offSetVal+"%";
			rightVal = - offSetVal+"%";
			opacity = 2.5+(scrollValFade/250);
			
			if(offSetVal > 0 || !$(this).is('[class*="-in"], [class*="-fadein"]')) // Prevent Movement
			{
				leftVal = 0;
				rightVal = 0;
			}
			
			if(offSetVal > 30) // Exit Animation
			{
				if($(this).is('[class*="-out"], [class*="-fadeout"]'))
				{
					leftVal = - Math.abs(offSetVal-30)+"%";
					rightVal = Math.abs(offSetVal-30)+"%";
					opacity = 0.5-(scrollValFade/250);
					
					if($(this).is('[class*="-fadeout"]')){$(this).css({'opacity':opacity});} // Add Fade Out
				}
			}
			
			var transform = "translate3d("+leftVal+",0,0)"; // Default Left In
			
			if($(this).is('[class*="scroll-fx-right-"]')) // Right
			{
				transform = "translate3d("+rightVal+",0,0)";
			}
			else if($(this).is('[class*="scroll-fx-up-left"]')) // Up & Left
			{
				transform = "translate3d("+leftVal+","+rightVal+",0)";
			}
			else if($(this).is('[class*="scroll-fx-up-right"]')) // Up & Right
			{
				transform = "translate3d("+rightVal+","+rightVal+",0)";
			}
			else if($(this).is('[class*="scroll-fx-down-left"]')) // Down & Left
			{
				transform = "translate3d("+leftVal+","+leftVal+",0)";
			}
			else if($(this).is('[class*="scroll-fx-down-right"]')) // Down & Right
			{
				transform = "translate3d("+rightVal+","+leftVal+",0)";
			}
			else if($(this).is('[class*="scroll-fx-up-"]')) // Up
			{
				transform = "translate3d(0,"+rightVal+",0)";
			}
			else if($(this).is('[class*="scroll-fx-down-"]')) // Down
			{
				transform = "translate3d(0,"+leftVal+",0)";
			}
			
			if(!$(this).hasClass('scroll-fx-fadein')){$(this).css({"-webkit-transform":transform});} // Add Transform
			if($(this).is('[class*="-fadein"]')){$(this).css({'opacity':opacity});} // Add fade
		}
	});
}