//*******************************************************************************
// Assset Library
//*******************************************************************************

window.TIMG; // Target image
window.TS; // Image Time Stamp Var
window.DT; // Delete target
window.hoverAssetURL; // Asset URL Mouse Is Over
window.selectMode = false; // Select Mode Bool
var selectInProgress = false;


$(document).ready(function()
{
	$('body').on('contextmenu', function(){
	  return false;
	});
	
	AALF(); // Activate Asset Library Features
	SUCM(); // Set up context menu
	PNDD(); // Prevent native drag and drop	
});


//*******************************************************************************
// Insert At Index
//*******************************************************************************


jQuery.fn.insertAt = function(index, element) {
  var lastIndex = this.children().size();
  if (index < 0) {
    index = Math.max(0, lastIndex + 1 + index);
  }
  this.append(element);
  if (index < lastIndex) {
    this.children().eq(index).before(this.children().last());
  }
  return this;
}

//*******************************************************************************
// Show Group Content - (Group Name)
//*******************************************************************************


function showGroupContent(GN)
{
	if(GN == 'all') // Show All
	{
		$('.gallery-thumb').show();
	}	
	else
	{
		$('.gallery-thumb').hide();
		$('[data-group~="'+GN+'"]').show();
	}
}


//*******************************************************************************
// Remove Group - (Group Name)
//*******************************************************************************


function removeGroup(GN)
{
	$('[data-group~="'+GN+'"]').each(function()
	{
		$(this).attr('data-group',removeAttrVal($(this).attr('data-group'),GN));
	});
	
	showGroupContent('all');
}


//*******************************************************************************
// Add / Remove Item To group
//*******************************************************************************

// Add Items To group
function addSelectedItemsToGroups(groupArray)
{	
	groupArray = groupArray.split(',');
	var selectedAssetArray = [];
	
	$('.selected').each(function(i) // Loop over selected objects
	{	
		var selectedItem = $(this);
		var selectedPath = getSelectedItemPath(selectedItem);

		$.each(groupArray,function(i,groupName) // Loop over selected objects
		{
			selectedItem.addAttrVal('data-group',groupName);
			var selectedGroups = selectedItem.attr('data-group');
			selectedAssetArray.push('{\"path\":\"'+selectedPath+'\",\"groups\":\"'+selectedGroups+'\"}'); // Store Data To Pass Back to Cocoa Side
		});
	});
	
	window.webkit.messageHandlers.addToGroup.postMessage(selectedAssetArray.join('/**COMMA**/'));
	
	$('.selected').removeClass('selected');
}

// Remove Items From Group
function removeSelectedItemsFromGroup(groupName)
{
	var selectedAssetArray = [];

	$('.selected').each(function(i) // Loop over selected objects
	{	
		var selectedItem = $(this);
		selectedItem.attr('data-group',removeAttrVal(selectedItem.attr('data-group'),groupName))
		
		var selectedPath = getSelectedItemPath(selectedItem);
		var selectedGroups = selectedItem.attr('data-group'); // Do this after group referance is removed
		selectedAssetArray.push('{\"path\":\"'+selectedPath+'\",\"groups\":\"'+selectedGroups+'\"}'); // Store Data To Pass Back to Cocoa Side
	});
	
	$('.selected').removeClass('selected');
	showGroupContent(groupName);

	window.webkit.messageHandlers.addToGroup.postMessage(selectedAssetArray.join('/**COMMA**/'));
}

// Get Selected Item Path
function getSelectedItemPath(item)
{
	var targetItem = item.closest('.gallery-thumb').find('img');
	var assetPath = targetItem.attr("src");
	
	if(assetPath == "img/app-mp4-thumb.png" || assetPath == "img/app-pdf-thumb.png" || assetPath == "img/app-zip-thumb.png" || assetPath == "img/app-mp3-thumb.png")
	{
		assetPath = targetItem.attr("data-asset-path");
	}
	
	return assetPath;
}

// Update Group Name
function updateGroupName(oldName,newName,MG)
{
	var mergeGroup = parseInt(MG);
	var updatedGroupArray = [];
	
	$('[data-group~="'+oldName+'"]').each(function() // Loop all items with target group
	{
		var selectedItem = $(this);
		
		selectedItem.attr('data-group',removeAttrVal(selectedItem.attr('data-group'),oldName)+' '+newName); // Update Group Attribute Data
		updatedGroupArray.push('{\"path\":\"'+getSelectedItemPath(selectedItem)+'\",\"groups\":\"'+selectedItem.attr('data-group')+'\"}'); // Store Data To Pass Back to Cocoa Side
	});
	
	window.webkit.messageHandlers.addToGroup.postMessage(updatedGroupArray.join('/**COMMA**/'));
	
	if(mergeGroup) // Show Al Group Content
	{
		showGroupContent(newName);
	}
}


//*******************************************************************************
//   Search Filter Assets Within Group
//*******************************************************************************


function filterAssets(GN,V)
{
	$('.gallery-thumb').hide(); // Hide All Items
	
	var targetItems = $('.gallery-thumb');

	if(GN == 'blocsapp-hosted-assets') // Hosted Assets
	{
		targetItems = $('.hosted-asset');
	}
	else if(GN != 'all') // Target Specific Group
	{
		targetItems = $('[data-group~="'+GN+'"]');
	}
		
	var resultCount = 0;
	targetItems.each(function() // Loop all target items
	{	
		if(V.length > 0) // Search Value Valid
		{	
			var fileName = getFileName($(this).find('img')).toLowerCase().replace(/%20/g,' ');
			
			if(fileName.indexOf(V) != -1) // Found Match
			{
				resultCount += 1;
				$(this).show(); // Show Results
			}
		}
		else
		{
			$(this).show(); // Show all in Group
		}
	});
	
	window.webkit.messageHandlers.searchLabel.postMessage(resultCount);
}

// get FileName
function getFileName(T)
{
	var fileName = '';
	
	if(T.hasAttr('data-asset-path')) // None Image File
	{
		fileName = T.attr("data-asset-path").split('/').pop();
	}
	else // Image
	{
		fileName = T.attr("data-src").split('/').pop();
	}
	
	return fileName;
}


//*******************************************************************************
// Select Mode
//*******************************************************************************

function toggleSelectMode(V)
{
	selectMode = parseInt(V);
	$('.selected').removeClass('selected');
}

function selectAll(GN)
{
	$('.selected').removeClass('selected');
	var target = $('[data-group~="'+GN+'"]').closest('.gallery-thumb');
	
	if(GN == 'all') // Handle All Group
	{
		target = $('.gallery-thumb');
	}
	
	target.addClass('selected');
	window.webkit.messageHandlers.selectedCount.postMessage($('.selected').length); // Show Selection Options	
}

//*******************************************************************************
// Basic Asset Library functions
//*******************************************************************************

// Activate Asset Library Features
function AALF()
{
	$("#assetLibrary").on("mousedown",'.gallery-thumb',function(event) 	// Inital Selection
	{	
		if(!event.ctrlKey) // Control key not down
		{
			TIMG = $(this); // Set target object
			window.webkit.messageHandlers.select.postMessage("setPAT/**ASSETDATA**/"+isPattern());
		}
	});
	
	$("#assetLibrary").on("click",'.gallery-thumb',function(event) 	// Gallery image click
	{	
		if (selectMode) // Select Mode
		{
			$(this).toggleClass('selected');
			window.webkit.messageHandlers.selectedCount.postMessage($('.selected').length); // Show Selection Options	
		}
		else // Normal Mode
		{
			if(!event.ctrlKey) // Control key not down
			{				
				TS = TIMG.find('img').attr('data-ts'); // Get time stamp value
				var URL = TIMG.find('img').attr('src').replace('?timestamp='+TS,''); // Image URL
			
				if(URL == "img/app-mp4-thumb.png" || URL == "img/app-pdf-thumb.png" || URL == "img/app-zip-thumb.png" || URL == "img/app-mp3-thumb.png") // Video, PDF, Zip, MP3 file so update url
				{
					URL = TIMG.find('img').attr('data-asset-path');
				}
				window.webkit.messageHandlers.select.postMessage(URL+'/**ASSETDATA**/'+GTS()); // Use image	
				selectInProgress = true;
			}
		}
	}
	).on("dragstart",'.gallery-thumb img',function(event) 	// Gallery image click
	{
		var imgSrc = $(this).attr('src');
		
		if(imgSrc == "img/app-mp4-thumb.png" || imgSrc == "img/app-pdf-thumb.png" || imgSrc == "img/app-zip-thumb.png" || imgSrc == "img/app-mp3-thumb.png") // Video file so update url
		{
			window.webkit.messageHandlers.dragSpecial.postMessage($(this).attr('data-asset-path')); // Use image	
		}
	}
	).on("mouseover",'.gallery-thumb',function(event) // Gallery Mouse Over
	{	
		if(!selectMode) // Not Select Mode
		{
			var targetItem = $(this).closest('.gallery-thumb').find('img');
			var URL = targetItem.attr('src'); // Image URL
		
			if(targetItem.hasClass('special-file')) // MP4, MP3, PDF, ZIP
			{
				hoverAssetURL = targetItem.attr('data-asset-path');
			}
			else // Basic image File
			{
				hoverAssetURL = URL;
				window.webkit.messageHandlers.mouseOver.postMessage(URL);
			}
		}
	}
	).on("mouseleave",'.gallery-thumb',function(event) 	// Gallery Mouse Leave
	{	
		if(!selectMode) // Not Select Mode
		{
			window.webkit.messageHandlers.mouseLeave.postMessage('');
		}
	});
}


//*******************************************************************************
// Communication with main window functions
//*******************************************************************************


// Check if image is a background pattern
function isPattern()
{
	var isPattern = "false";
	
	if(TIMG.attr('data-group').indexOf('patterns') != -1) // In Pattern Group
	{
		isPattern = "true";
	}	
	return isPattern;
}

// Get image time stamp
function GTS()
{	
	return ""+TS;
}


//*******************************************************************************
// Select Asset
//*******************************************************************************


function setSelectedAsset(D)
{
	$('.selected').removeClass('selected'); // Remove Selected Object
	
	if(D != 'no-asset')
	{
		var targetImage = $('.gallery-thumb img[src^="'+D+'"]');
		var targetFile = $('.gallery-thumb img[data-asset-path="'+D+'"]');
	
		if(targetImage.length) // Found Image
		{
			targetImage.closest('.gallery-thumb').addClass('selected'); // Apply Selected Class To Thumb
		}
		else if(targetFile.length) // Found File  MP4, MP3, ZIP, PDF
		{
			targetFile.closest('.gallery-thumb').addClass('selected'); // Apply Selected Class To Thumb
		}
		else if(D.indexOf('/Blocs.app/Contents/Resources/img/')) // Check For Local Resource
		{
			D = 'img/'+D.split('/').pop(); // Get Local File Path
			targetImage = $('.gallery-thumb img[src="'+D+'"]');
			targetImage.closest('.gallery-thumb').addClass('selected'); // Apply Selected Class To Thumb
		}
	}
}

// Scroll To Selected
function scrollToSelected()
{
	// Scroll To Selected Item If Visible
		if ($(".selected").is(':visible'))
		{
			if (!selectInProgress)
			{
				$('.main-container').scrollTop(0).scrollTop($(".selected").offset().top); // Scroll To Asset 
			}
			selectInProgress = false;
		}
}

// Scroll To Item At Index
function scrollToItemAtIndex(idx)
{
	$('.main-container').scrollTop(0).scrollTop($('#project-asset-items').children().eq(idx).offset().top);
}

//*******************************************************************************
// Browse local hard drive for images
//*******************************************************************************

function BLHD()
{
	window.webkit.messageHandlers.browse.postMessage(''); // Trigger cocoa browse dialog
}

//*******************************************************************************
// Delete selected Asset
//*******************************************************************************

// Delete Selected Assets
function deleteSelectedAssets()
{
	$('.selected').each(function(i) // Loop over selected objects
	{	
		DT = $(this).find('img');
		DSA();
	});
}

// Delete Selected Asset
function DSA()
{	
	if(selectMode) // Remove Multiple
	{
		$('.selected').each(function(i) // Loop over selected objects
		{
			removeAsset($(this));
		});
	}
	else // Remove Single
	{
		removeAsset(DT);
	}
}

// Process Remove Asset
function removeAsset(targetAsset)
{
	if(targetAsset.prop('tagName') != 'IMG') // If not image then re-target image
	{
		targetAsset = targetAsset.closest('.gallery-thumb').find('img');
	}
	
	var assetPath = targetAsset.attr("src"); // Default img src
	
	if(assetPath == "img/app-mp4-thumb.png" || assetPath == "img/app-pdf-thumb.png" || assetPath == "img/app-zip-thumb.png" || assetPath == "img/app-mp3-thumb.png")
	{
		assetPath = targetAsset.attr("data-asset-path");
	}
	
	window.webkit.messageHandlers.delete.postMessage(assetPath);
	
	targetAsset.closest('.gallery-thumb').remove(); // remove thumb from ui
}


//*******************************************************************************
// Refresh selected Asset
//*******************************************************************************


function RSA()
{	
	if (selectMode)
	{
		$('.selected').each(function(i) // Loop over selected objects
		{
			var imgPath = $(this).find('img').attr("src");

			if (imgPath.indexOf('tempAssetStorage/ExternalDrives/') !=-1) // Temp Storage Image
			{
				window.webkit.messageHandlers.tempStorageRefresh.postMessage(imgPath);
			}
			else // Normal Image
			{
				window.webkit.messageHandlers.refresh.postMessage(imgPath);
				RFIA(imgPath);
			}
		});
	}
	else
	{
		if (DT.prop('tagName') != 'IMG') // If not image then re-target image
		{
			DT = DT.closest('.gallery-thumb').find('img');
		}

		var imgPath = DT.attr("src");
		
		if (imgPath.indexOf('tempAssetStorage/ExternalDrives/') !=-1) // Temp Storage Image
		{
			window.webkit.messageHandlers.tempStorageRefresh.postMessage(imgPath);
		}
		else // Normal Image
		{
			window.webkit.messageHandlers.refresh.postMessage(imgPath);
			RFIA(imgPath);
		}
	}
}


// Refresh image asset
function RFIA(path)
{
	var timeStamp = new Date().getTime(); // Image time stamp
	
	$("img[src*='"+path+"']").each(function()
	{
		if($(this).attr('src').indexOf('?timestamp=') != -1) // Already has a time stamp update it
		{
			$(this).attr('src',$(this).attr('src').replace($(this).attr('data-ts'),timeStamp)).attr('data-ts',timeStamp);
		}
		else // No time stamp add one
		{
			$(this).attr('src',$(this).attr('src')+"?timestamp=" + timeStamp).attr('data-ts',timeStamp);	
		}	
	});	
}


//*******************************************************************************
// Content Menu
//*******************************************************************************


// Set up context menu
function SUCM()
{
	$(document).mousedown(function(event)
	{
	    switch (event.which)
		{
			case 1:	
				if(event.ctrlKey) // ctr + click support
				{
					CACM($(event.target),event); // Create app context menu
				}
			break;
	        case 3:	
				CACM($(event.target),event); // Create app context menu
	       break;
	    }
	});
}

// Create menu
function CACM(D,E)
{	
	DT =  D; // Set delete target
	if(D.closest('.gallery-thumb').length)
	{
		if(D.prop('tagName') == 'IMG')
		{
			D = D.closest('.gallery-thumb');
		}
		
		if(D.closest('#asset-container').length)
		{
			if($('.img-active').length) // If image another image is active remove its styling
			{
				$('.img-active').removeClass('img-active') 
			}
			D.addClass('img-active') // Set selected image
			
			var targetItem = D.find('img');
			var hasLightBg = D.hasClass('trans-bg');
			var isHosted = D.hasClass('hosted-asset');

			if(targetItem.hasAttr('data-asset-path')) // MP4,MP3,PDF,ZIP
			{
				var filePath = targetItem.attr('data-asset-path');
				var fileType = filePath.toLowerCase();
				fileType = fileType.substring(fileType.lastIndexOf('.') + 1);
				
				window.webkit.messageHandlers.context.postMessage(fileType+','+isHosted+','+hasLightBg+','+filePath);
			}
			else // Image context menu
			{
				var filePath = targetItem.attr('src').replace(/,/g,'/**COMMA**/');
				window.webkit.messageHandlers.context.postMessage("image,"+isHosted+','+hasLightBg+','+filePath);
			}
		}
		else
		{
			window.webkit.messageHandlers.context.postMessage("hide"); // Hide Context Menu
		}
	}
	else
	{
		window.webkit.messageHandlers.context.postMessage("hide"); // Hide Context Menu
	}
}

// Get Active Asset Preview
function GAAP()
{
	return "/"+$('.img-active').find('img').attr('data-asset-path');
}

// Get Hover Image Path
function OHIP()
{
	return hoverAssetURL;
}

//*******************************************************************************
// Load External Drive Images - Update to temp work paths
//*******************************************************************************


// Update fixed Image data
function UFID(N,O,OE)
{
	O = O.split('*0*IMAGE**URL*0*'); // OLD image path array
	OE = OE.split('*0*IMAGE**URL*0*'); // Old ESCAPED image path array
	N = N.split('*0*IMAGE**URL*0*'); // NEW image path array
	
	$.each(N, function(i) // Loop over all target images and fix them
	{	
		ROIS(N[i],O[i],OE[i]); // Replace Old Image String
		setTimeout(function(){RFIA(N[i]);}, 100); // Add Time Stamp
	});
}

// Replace Old Image String
function ROIS(newPath,oldPath,oldPathEsc)
{	
	$('.gallery-thumb img[data-src="'+oldPath+'"]').attr('data-src',newPath).attr('src',newPath); // Update old image path
	$('.gallery-thumb img[data-asset-path="'+oldPath+'"]').attr('data-asset-path',newPath); // Update Old Asset Path (Zip | PDF |MP4 | MP3)

	// Check For Escaped Characters
	$('.gallery-thumb img[data-src="'+oldPathEsc+'"]').attr('data-src',newPath).attr('src',newPath); // Update old image path
	$('.gallery-thumb img[data-asset-path="'+oldPathEsc+'"]').attr('data-asset-path',newPath); // Update Old Asset Path (Zip | PDF |MP4 | MP3)

	// Is Embeded Asset
	if (newPath.indexOf('/embedded-blocs-assets/') !=-1)
	{
		$('.gallery-thumb img[data-src="'+newPath+'"]').parent().parent().removeClass('linked-asset'); // Add Class
		$('.gallery-thumb img[data-asset-path="'+newPath+'"]').parent().parent().removeClass('linked-asset'); // Add Class
	}
}


// Set New File Name
function setNewFileName(newPath)
{
	var newFileName = newPath.split('\\').pop().split('/').pop();
	$('.gallery-thumb img[data-src="'+newPath+'"]').parent().parent().find('p[title]').text(newFileName);
}


//*******************************************************************************
// Prevent native drag and drop
//*******************************************************************************

function PNDD()
{
	$(window).on("dragover", function(event) // Override drag over window - Used for external image drops
	{
		event = event.originalEvent;
		event.preventDefault();	
	}).on('drop dragdrop',function(event)
	{	
		event = event.originalEvent;
		event.preventDefault();
	});	
}

// Reset window
function RSW()
{
	$('#user-library').html('');
}

//*******************************************************************************
// Loading Screen
//*******************************************************************************


function loadingData(V)
{
	if (V) // Show Loading Screen
	{
		$('#assetLibrary').addClass('loading-data');
	}
	else // Hide Screen
	{
		$('#assetLibrary').removeClass('loading-data');
	}
}



//*******************************************************************************
// Plugins
//*******************************************************************************


// Has Attribute
$.fn.hasAttr = function(name){return this.attr(name) !== undefined;};

// Add Attr Val
$.fn.addAttrVal=function(t,a){var i=this.attr(t);if(-1==i.indexOf(a))i+=" "+a;else{var n=i.split(" "),e=!0;$.each(n,function(t,i){i.length>0&&i==a&&(e=!1)}),e&&(i+=" "+a)}this.attr(t,i)};



// Remove Attribute Value
function removeAttrVal(D,V)
{	
	var dataArray = D.split(' ');
	var newdataArray = [];
	$.each(dataArray, function(i,itemVal){if(itemVal.length > 0){if(itemVal != V){newdataArray.push(itemVal);}}});
	return newdataArray.join(' ');
}

