//*******************************************************************************
// Blocs Developer API 1.0
//*******************************************************************************

window.customBricAttr;
window.customBricFunc;
window.customBricImgRes = 1;
window.customBricUNDOStarted = false;

//*******************************************************************************
// Custom Brics
//*******************************************************************************

// Set Cutsom Bric Attribute Value (Attribute | Value)
function SCBAV(A,V)
{
	V = V.replace(/"/g,'\\"'); // Force Esacpe Quotes
	
	SDCS('Custom Bric Change');
	TIO.closest('custombric').attr(A,V);
	customBricUNDOStarted = true;
}

// Update Custom Bric HTML
function UDCBHTML(D)
{
	if(!customBricUNDOStarted){SDCS('Custom Bric Change');} // Undo Start has not been triggered by attribute change
	
	var T = TIO.closest('custombric');
	T.html(D);
	TIO = T;
	SUDS('Custom Bric Change'); // Save current state
	customBricUNDOStarted = false;
	setTimeout(function(){AEOM();}, 400);
}

// Get Custom Bric Name
function GCBN(T)
{
	return T.closest('custombric').attr('custom-bric-name');
}


// Target Custom Bric Image Attr - (Attribute | Function | Image Resolution)
function TCBIA(A,F,R)
{
	customBricAttr = A;
	customBricFunc = F;
	customBricImgRes = R;
	ITO = 100; 
	AAL();
}


// Get Custom Bric Attribute data
function GCBAD()
{
	var customBricDataArray = [];
	var customAttrNames = [];
	
	GTO().each(function()
	{
		$.each(this.attributes, function()
		{
			if(this.specified)
			{
				var itemName = this.name;
				var Item = "\""+itemName+"\":\""+this.value+"\"";
				
				if(itemName != 'class') // Store Custom Attibutes
				{
					if($.inArray(itemName, customAttrNames) == -1) // Attribute Not In Array
					{
						customAttrNames.push(itemName);
					}
				}
				
				// Store Attribute Items
				if($.inArray(Item, customBricDataArray) == -1) // Attribute Not In Array
				{
					customBricDataArray.push(Item.replace(/\n/g,'\\n'));
				}
	    	}
	  	});
	});

	var attrItemKey = "\"custom-attr-items\":\""+customAttrNames.join(',')+"\",";
	var attrData = attrItemKey+customBricDataArray.join(',');	
	
	return attrData;
}

// Add Custom Bric Style Sheet - (bric ID | Style Sheet Data)
function ACBSS(ID,SD)
{
	if($('style[style-id="'+ID+'"]').length) // Update Style Sheet
	{
		$('style[style-id="'+ID+'"]').text(SD);
	}
	else // Add Style Sheet To Head If Doesnt Exist
	{
		$('<style style-id="'+ID+'" class="custom-bric-styledata" type="text/css">'+SD+'</style>').appendTo($('head'));
	}
}

// Handle Custom Brics in Blocs
function setUpCustomBricsInBloc(targetObj,isPageTemplate)
{
	if (targetObj.find('custombric').length) // Has Custom Brics
	{
		targetObj.find('custombric').each(function() // Loop Custom Brics
		{
			var targetBric = $(this);
			var bricID = targetBric.attr('target-id');
			
			if (!$('style[style-id="'+bricID+'"]').length) // Add Bric Core Style Sheet
			{
				window.webkit.messageHandlers.customBricCoreStyling.postMessage(bricID);
			}
			
			if (!isPageTemplate) // Add Page Attachments When Not A Page Template (they already exist)
			{
				window.webkit.messageHandlers.customBricResource.postMessage('{"id":"'+bricID+'","global":"'+(targetBric.closest('.page[data-pn]').length==0)+'"}'); // Add Resources
			}
		});

		if (isPageTemplate) // Adding Page Template So set default Template data if Bric is Installed.
		{
			setInitialCustomBricTemplateState(targetObj);
		}
		else // Duplicating a Bloc So Copy Template Data
		{
			duplicateChildCustomBricTemplateItems(targetObj); // Handle Custom Bric Template Files
		}
	}
}

// Handle Custom Brics in Page Template
function setUpCustomBricsInPageTemplate()
{
	var targetPage = $("#pc-"+AP);
	setUpCustomBricInPageZone(targetPage);
	
	if(!targetPage.hasAttr('hide-nav-area')) // Has Global Top
	{
		setUpCustomBricInPageZone($("#pc-nav"));
	}

	if (!targetPage.hasAttr('hide-footer-area')) // Has Global Bottom
	{
		setUpCustomBricInPageZone($("#pc-footer"));
	}
}

// Handle Custom Brics in Page Zone
function setUpCustomBricInPageZone(targetZone)
{
	if (targetZone.find('custombric').length) // Has Custom Brics
	{
		targetZone.find('.bloc > .container').each(function() // Loop Blocs
		{
			setUpCustomBricsInBloc($(this),true);
		});
	}
}

//*******************************************************************************
// Check Custom Brics After Undo
//*******************************************************************************


function checkCustomBricsAfterUndo()
{
	$("#pc-nav custombric, #pc-footer custombric, .page[data-pn="+AP+"] custombric").each(function() // Loop All Brics
	{
		var bricID = $(this).attr('target-id');

		if (!$('style[style-id="'+bricID+'"]').length) // Add Bric Core Style Sheet
		{
			window.webkit.messageHandlers.customBricCoreStyling.postMessage(bricID);
		}
	});
}


//*******************************************************************************
// Remove Custom Brics Style Sheets From page
//*******************************************************************************


// Remove Custom Bric Style Sheet
function RCBSS(ID)
{
	if ($('#doc-root').find('custombric[target-id="'+ID+'"]').length == 0) // No Brics in site (remove styling and resources)
	{
		$('style[style-id="'+ID+'"]').remove(); // Remove Style Sheet
		window.webkit.messageHandlers.removeCustomBricID.postMessage('{"id":"'+ID+'","global":"'+(TIO.closest('.page[data-pn]').length==0)+'"}');
	}
	else // No Brics in page (remove resources only)
	{
		if (isLastCutomBricOnPage(ID,TIO)) // Is this the last type of custom bric on this page?
		{
			window.webkit.messageHandlers.removeCustomBricResources.postMessage('{"id":"'+ID+'","global":"'+(TIO.closest('.page[data-pn]').length==0)+'"}');
		}
	}
}

// Find Custom Bric In HTML String
function FCBIHTML(HTML)
{	
	var customBricIDArray = [];
	if(HTML.indexOf('<custombric target-id="').length !=-1) // Found Custom Bric in String
	{
		var tempDataArray = HTML.split('<custombric target-id="');
		
		$.each(tempDataArray, function(i,itemVal) // Loop Temp Data Array
		{
			if(i > 0) // Ignore First Item
			{
				var bricID = itemVal.substring(0,itemVal.indexOf('"'));

				if($.inArray(bricID, customBricIDArray) == -1) // Check ID Not In Array
				{
					RCBSS(bricID); // Remove Custom Bric Style Sheet
					customBricIDArray.push(bricID);
				}
			}
		});
	}
}


// Is Last Custom Bric On Page
function isLastCutomBricOnPage(ID,targetBric)
{
	isLastCustomBric = true;

	if (targetBric.closest('.page[data-pn]').length == 0) // Bric is Global
	{
		if (targetBric.closest('#pc-nav').length) // Nav Global
		{
			if ($('#pc-nav custombric[target-id="'+ID+'"]').length > 1 || $('#pc-footer custombric[target-id="'+ID+'"]').length > 0)
			{
				isLastCustomBric = false;
			}
		}
		else // Footer Global
		{
			if ($('#pc-footer custombric[target-id="'+ID+'"]').length > 1 || $('#pc-nav custombric[target-id="'+ID+'"]').length > 0)
			{
				isLastCustomBric = false;
			}
		}
	}
	else if ($('#pc-'+AP+' custombric[target-id="'+ID+'"]').length > 1) // Bric is Dynamic
	{
		isLastCustomBric = false;
	}

	return isLastCustomBric;
}

//*******************************************************************************
// Move Custom Brics Between Page Zones
//*******************************************************************************


// Move Resources Between Page Zones
function moveResourcesBetweenPageZones(targetObj,newLocationIsGlobal)
{
	var scanTarget = targetObj;

	if (scanTarget.closest('.bloc').length != 0) // Not Bloc Find Parent
	{
		scanTarget = targetObj.parent();
	}

	if (scanTarget.find('custombric').length) // Has Custom Brics
	{
		scanTarget.find('custombric').each(function() // Loop Custom Brics
		{
			var targetBric = $(this);
			var bricID = targetBric.attr('target-id');

			if (isLastCutomBricOnPage(bricID,targetBric)) // Is this the last type of custom bric on this page?
			{
				window.webkit.messageHandlers.moveCustomBricResources.postMessage('{"id":"'+bricID+'","old-global":"'+!newLocationIsGlobal+'","new-global":"'+newLocationIsGlobal+'"}');
			}

			if (targetBric.hasAttr('custom-bric-unique-id')) // Has Unique ID
			{
				var bricUniqueID = targetBric.attr('custom-bric-unique-id');
				window.webkit.messageHandlers.moveCustomBricTemplate.postMessage('{"uniqueID":"'+bricUniqueID+'","global":"'+newLocationIsGlobal+'"}'); // Move Custom Bric Template Bewteen Zones
			}
		});
	}
}

// Check For Moved Custom Brics Via Layer Tree
function checkForMovedCustomBricsViaLayerTree(dragSelector, dropParentSelector)
{
	var targetObj = dragSelector;

	if (dragSelector.is('custombric')) // Drag item is a custom bric so retartet to parent
	{
		targetObj = dragSelector.parent();
	}

	var newLocationIsGlobal = (dropParentSelector.closest('.page[data-pn]').length==0);
	moveResourcesBetweenPageZones(targetObj,newLocationIsGlobal);
}


//*******************************************************************************
// Disable/ Enable Custom Brics
//*******************************************************************************


function toggleCustomBrics(hideBrics)
{
	if($('custombric').length)
	{
		var stylesheet = document.querySelector('.custom-bric-styledata');

		if(hideBrics == 1) // Hide
		{
			stylesheet.disabled = true;
			$('custombric').addClass('custom-bric-hide');
			$('#active-object').remove();	
		}
		else // Show
		{
			stylesheet.disabled = false;
			$('custombric').removeClass('custom-bric-hide');
		}	
	}
}

//*******************************************************************************
// Remove The Custom Bric Children Template Items
//*******************************************************************************


function removeChildCustomBricTemplateItems(targetObj, isGlobal)
{
	if (targetObj.find('custombric').length) // Contains Custom Bric Children
	{
		targetObj.find('custombric').each(function() // Loop Custom Brics
		{
			removeChildCustomBricPageAttachments($(this).attr('target-id'),isGlobal);

			if ($(this).hasAttr('custom-bric-unique-id')) // Has Unique ID
			{
				window.webkit.messageHandlers.removeCustomBricTemplateItems.postMessage($(this).attr('custom-bric-unique-id')); // Remove Template Items
			}
		});
	}
}


//*******************************************************************************
// Remove The Custom Bric Children Page Attachments
//*******************************************************************************


function removeChildCustomBricPageAttachments(bricID,isGlobal)
{
	if ($('#doc-root').find('custombric[target-id="'+bricID+'"]').length == 0) // No Brics
	{
		$('style[style-id="'+bricID+'"]').remove(); // Remove Style Sheet
		window.webkit.messageHandlers.removeCustomBricID.postMessage('{"id":"'+bricID+'","global":"'+isGlobal+'"}');
	}
}


//*******************************************************************************
// Duplicate The Custom Bric Children Template Items
//*******************************************************************************


function duplicateChildCustomBricTemplateItems(targetObj)
{
	if (targetObj.find('custombric').length) // Contains Custom Bric Children
	{
		targetObj.find('custombric').each(function() // Loop Custom Brics
		{
			if ($(this).hasAttr('custom-bric-unique-id')) // Has Unique ID
			{
				var newID = $(this).attr('target-id')+'-'+GUBN();
				window.webkit.messageHandlers.duplicateCustomBricTemplateItems.postMessage('{\"oldID\":\"'+$(this).attr('custom-bric-unique-id')+'\", \"newID\":\"'+newID+'\"}');
			}
		});
	}
}

//*******************************************************************************
// Add Intial Template Data For Each Bric
//*******************************************************************************

function setInitialCustomBricTemplateState(targetObj)
{
	if (targetObj.find('custombric').length) // Contains Custom Bric Children
	{
		targetObj.find('custombric').each(function() // Loop Custom Brics
		{
			if ($(this).hasAttr('custom-bric-unique-id')) // Has Unique ID
			{
				var bricID = $(this).attr('target-id');
				var uniqueID = $(this).attr('target-id')+'-'+GUBN();
				$(this).hasAttr('custom-bric-unique-id',uniqueID); // Store Unique ID on Bric

				window.webkit.messageHandlers.pageTemplateCustomBricSetTemplateData.postMessage(bricID); // Set Template Initial State
				window.webkit.messageHandlers.addCustomBricInitTemplateVal.postMessage('{\"bricID\":\"'+bricID+'\", \"uniqueID\":\"'+uniqueID+'\", \"global\":\"'+($(this).closest('.page[data-pn]').length == 0)+'\"}');
			}
		});
	}
}


//*******************************************************************************
// Old API - LEGACY
//*******************************************************************************


// Bloc backgrounds
window.BBSA = [".bg-center",".bg-repeat",".bg-l-edge",".bg-r-edge",".bg-t-edge",".bg-b-edge",".bg-tl-edge",".bg-tr-edge",".bg-bl-edge",".bg-br-edge"]; // Bloc background style array
window.CBBSAD = []; // Custom background style class data

// Buttons
window.BTNSA = [".btn-clean",".btn-glossy",".btn-wire"]; // Button style array
window.CBTNSD = []; // Custom Button style class data

// Image style 
window.IMGSA = [".img-frame",".img-frame-md",".img-frame-lg",".img-frame-rd",".img-frame-rd-md",".img-frame-rd-lg",".rounded",".img-rd-md",".img-rd-lg"]; // Image style array
window.CIMGSD = []; // Custom Image style class data


// Text Style
window.TXTSA = [".sm-shadow",".lg-shadow",".pressed-t",".glow-t",".threeD-t"]; // Text style array
window.CTXTSD = []; // Custom Text style class data


// Animation
window.AOA = [".fadeIn",".fadeInUp",".fadeInDown",".fadeInLeft",".fadeInRight",".bounce",".bounceIn",".bounceInUp",".bounceInDown",".bounceInLeft",".bounceInRight",".zoomIn",".zoomInUp",".zoomInDown",".zoomInLeft",".zoomInRight",".flash",".pulse",".rubberBand",".shake",".swing",".tada",".wobble",".flip",".flipInX",".flipInY",".lightSpeedIn",".rotateIn",".rollIn", ".jello",".puffIn",".vanishIn"]; // Animation object array
window.CAOA = []; // Custom Animation object class data


// Initiate API
function IAPI(D)
{
	BSFD = D; // Set bloc directory global var
}

// Refresh Extensions
function RFE()
{
	var D = $("#APIroot").attr("src")+"?"+ new Date().getTime(); // Create new EX path
	$("#APIroot").remove(); // Remove old extension link	
	$('head').append('<script id=\"APIroot\" type=\"text/javascript\" src="'+D+'"></script>'); // Re-add EX JS
}

//*******************************************************************************
// Add Custom Blocs
//*******************************************************************************

// Add custom bloc set - Name | Icon 12x12px
function addBlocSet(N,I)
{
	$('#blocSelect').append('<li><div data-target="'+N+'" class="blocsapp-nav-btn">'+N+'</div></li>');
	$('#options-content').append('<div id="'+N+'" class="sb-options-set"></div>');
}

// Add custom bloc option - Set Name | Data | Image
function addBlocOptions(N,D,I)
{	
	$.each(D,function(i) // Loop array and build Ui
	{	
		$('#'+N).append('<button type="button" class="ui-btn" onClick="createBloc('+D[i].replace(/'/g,"\'")+')"><img src="'+BSFD+'/blocs/'+N+'/'+I[i]+'"></button>');
	});	
}

// Create custom bloc on page
function createBloc(D)
{
	AB(); // Add bloc
	$("#bloc-"+CB+' div.bloc').replaceWith(bloc+D);
	SUBO(); // Set up bloc options 	
};


//*******************************************************************************
// Add Custom Styles
//*******************************************************************************


// Add custom Background style 
function addBackgroundStyle(N,D)
{
	var TEP = "{"; // Target end point
	if(D.substring(0,D.indexOf('{')).indexOf(',') !=-1 ) // If class rule name has comma fix
	{
		TEP = ","// Target end point
	}
	BBSA.push(D.substring(0,D.indexOf(TEP))); // Push new class name to Background style array
	CBBSAD.push(D); // Push new class data to Custom Background style class data
	$('#custom-imported-classes').append(D)
	$('#blocsapp-bloc-background-position').append('<option data-class="'+D.substring(1,D.indexOf(TEP))+'">'+N+'</option>'); // Add new option to list
}

// Add custom Text style 
function addTextStyle(N,D)
{
	var TEP = "{"; // Target end point
	if(D.substring(0,D.indexOf('{')).indexOf(',') !=-1 ) // If class rule name has comma fix
	{
		TEP = ","// Target end point
	}
	TXTSA.push(D.substring(0,D.indexOf(TEP))); // Push new class name to Text style array
	CTXTSD.push(D); // Push new class data to Custom Text style class data
	$('#custom-imported-classes').append(D);
	$("#iconStyle li:last-child, #textStyle li:last-child").before('<li class="extension" data-class="'+D.substring(1,D.indexOf(TEP))+'">'+N+'<span class="appicon-extension"></span></li>');// Add new option to list
}

// Add custom Button style 
function addButtonStyle(N,D)
{
	var TEP = "{"; // Target end point
	if(D.substring(0,D.indexOf('{')).indexOf(',') !=-1 ) // If class rule name has comma fix
	{
		TEP = ","// Target end point
	}
	BTNSA.push(D.substring(0,D.indexOf(TEP))); // Push new class name to Button style array
	CBTNSD.push(D); // Push new class data to Custom Button style class data
	$('#custom-imported-classes').append(D);
	$('#buttonStyle').append('<li class="extension" data-class="'+D.substring(1,D.indexOf(TEP))+'">'+N+'<span class="appicon-extension"></span></li>'); // Add new option to list
}









