//*******************************************************************************
// Layer Tree 3.0
//*******************************************************************************

window.domArray = [];
window.targetLayerTreeDropParent;

function populateLayerTree(reselectItem)
{
	if (reselectItem) // Reselect Item
	{
		window.webkit.messageHandlers.selectItemAfterLayerTreePop.postMessage('');
	}
	
	$('.bloc #drop-zone').remove();
	if (!$('#pc-'+AP).hasAttr('hide-nav-area')) // Include Nav Blocs
	{
		getLayerTreeData('#pc-nav .bloc'); // Top Global Blocs
	}
	
	getLayerTreeData('#pc-'+AP+' .bloc'); // Active Page Blocs
	
	if (!$('#pc-'+AP).hasAttr('hide-footer-area')) // Include Footer Blocs
	{
		getLayerTreeData('#pc-footer .bloc'); // Bottom Global Blocs
	}
	
	window.webkit.messageHandlers.populateLayerTree.postMessage(domArray.join("/**/"));
	domArray = []; // Clear Array
}

// Populate layer tree area
function getLayerTreeData(targetSection)
{
	$(targetSection).each(function(i) // Loop Blocs
	{
		var blocID = $(this).attr('id'); // Bloc ID
		var blocNumber = $(this).parent().attr('data-bn'); // Bloc Number
		var isGlobalItem = !$(this).closest('.page').length;
		var bricID = getObjectAttr($(this),'id');
		var blocClasses = getObjectAttr($(this),'data-custom-classes');
		var insideGroup = $(this).closest('.bloc-group').length;
		var lastChild = $(this).closest('.bloc-container').is(':last-child');
		var layerColor = getObjectAttr($(this),'data-blocsapp-layer-color');
	
		if(!$(this).hasAttr('id')) // Bloc has no ID use index
		{
			blocID = i+1;
		}
		
		var blocData = '{\"type\":\"Bloc\", \"tag\":\"Bloc\", \"blocID\":\"'+blocNumber+'\", \"id\":\"'+blocID+'\", \"bricID\":\"'+bricID+'\", \"inBlocGroup\":\"'+insideGroup+'\", \"customClasses\":\"'+blocClasses+'\", \"isContainer\":"true", \"isGlobal\":"'+isGlobalItem+'", \"isLocked\":"false", \"layerColor\":"'+layerColor+'", \"isLastChild\":\"'+lastChild+'\", \"children\":['+getItemChildLayerData($(this));
		
		//debug('Bloc DATA '+blocData);
		domArray.push(blocData);
	});
}


// Get Item Child Layer Data
function getItemChildLayerData(targetItem)
{
	var blocNumber = targetItem.closest('.bloc-container > div').attr('data-bn'); // Bloc Number
	var blocChildData = '';
	var level = 0;
	var objIndex = 0;
	var parentLastChildLevel = 0;
	
	targetItem.find('*').each(function() // Loop Children
	{	
		var targetObject = $(this);
		var bricName = getLayerName(targetObject);
		var lastChild = isLastChild(targetObject);
		var tagName = targetObject.prop('tagName').toLowerCase();
		var isContainer = isLayerContainer(targetObject);
		var isLocked = isLayerLocked(targetObject);
		var parentStored = parentItemDataBeStored(targetObject.parent());
		var childIndex = targetObject.index();
		var bricID = getObjectAttr(targetObject,'id');
		var bricClasses = getObjectAttr(targetObject,'data-custom-classes');
		var layerColor = getObjectAttr(targetObject,'data-blocsapp-layer-color');

		//debug('BRIC NAME '+bricName);
		//debug('BRIC Style '+targetObject.attr('class'));
		
		if(targetObject.hasClass('blocsapp-hover-container') || targetObject.attr('id') == 'active-object' || targetObject.attr('id') == 'hover-object' || targetObject.attr('id') == 'hover-info' || targetObject.attr('id') == 'add-zone') // Prevent empty columns being added to layer tree
		{
			return false
		}
		
		var storeLayerData = shouldItemDataBeStored(targetObject);
		
		if(storeLayerData) // Store Layer Data
		{			
			blocChildData += '{\"type\":\"'+bricName+'\", \"tag\":\"'+tagName+'\", \"blocID\":\"'+blocNumber+'\", \"bricID\":\"'+bricID+'\", \"customClasses\":\"'+bricClasses+'\", \"isContainer\":\"'+isContainer+'\", \"parentStored\":\"'+parentStored+'\", \"isLocked\":"'+isLocked+'", \"layerColor\":"'+layerColor+'", \"childIndex\":\"'+childIndex+'\", \"isLastChild\":\"'+lastChild+'\", \"children\":[';

			if(lastChild) // Last Object on Level
			{
				parentLastChildLevel += 1;
			}
			

			if (hasChildren(targetObject)) // Has Children Go Down a Level
			{
				level += 1;	
			}
			else // No Children 
			{
				if(level > 0) // Has Levels to climb
				{
					if (lastChild) // Last Object on level
					{
						// Inital Step Up
						level -= 1;
						parentLastChildLevel -= 1;
						blocChildData += '\"none\"]}]}';
						
						if(targetObject.parent().is(':last-child')) // Parent is Last Child
						{
							var targetParent = targetObject.parent();
							var childLevels = parentLastChildLevel;

							for(var i = 0; i < childLevels; i++) // Loop Parent Child Levels
							{
								if(targetParent.is(':last-child') || level == 1)
								{
									targetParent = targetParent.parent();
									parentLastChildLevel -= 1;
									blocChildData += ']}';
									level -= 1;	
								}
							}
						}
					}
					else
					{
						blocChildData += '\"none\"]},';
					}
				}
				else // No levels to climb
				{	
					blocChildData += '\"none\"]}';
					
					if (targetObject.is(':last-child'))
					{
						if (targetObject.is('a > img, a > icon')) // Handle image and icons nested in a tags
						{
							if (targetObject.parent().is(':last-child'))
							{
								blocChildData += ']}';
							}
						}
						else // Last Element
						{
							blocChildData += ']}';
						}
					}
				}
			}
			
			objIndex ++;
		}	
	});
	
	return blocChildData.replace(/}{/g,"},{");
}


// Should Item Data be Stored
function shouldItemDataBeStored(T)
{
	var storeLayerData = true;
	
	if (T.is('.carousel-indicators li, .carousel-nav-controls, .carousel-nav-controls icon, .blocs-edge-hit-marker, .blocs-custom-html *, .twitter-share-button *, .bloc-shape-divider *') || T.hasClass('empty-column') || T.parent().is('.form-check, .custom-switch') || T.parent().closest('.embed-responsive, audio').length || T.parent().closest('.video-bg-container').length || T.is('.divider-h .divider, .divider-v .divider') || T.parent().closest('disqus-comments').length || T.parent().closest('custombric').length)
	{
		storeLayerData = false;
	}
	else if (T.is('.bloc a') && T.find('img').length || T.is('.bloc a') && T.find('icon').length && !T.hasClass('btn')) // Dont store image and icon wrapper links
	{
		storeLayerData = false;
	}
	else if (T.is('.ui-navbar-toggler span')) // Dont store nav toggle children
	{
		storeLayerData = false;
	}
	
	return storeLayerData;
}

// Parent Item Data be Stored
function parentItemDataBeStored(T)
{
	var storeLayerData = true;

	if (T.hasClass('empty-column') || T.parent().is('.form-check, .custom-switch') || T.parent().closest('.embed-responsive, audio').length || T.parent().closest('.video-bg-container').length)
	{
		storeLayerData = false;
	}
	else if (T.is('.bloc a') && T.find('img').length || T.is('.bloc a') && T.find('icon').length && !T.hasClass('btn')) // Dont store image and icon wrapper links
	{
		storeLayerData = false;
	}
	else if (T.is('.carousel-nav-controls')) // Dont store Carousel Controls
	{
		storeLayerData = false;
	}
	
	return storeLayerData;
}


// Check Object Is Layer Container
function isLayerContainer(T)
{
	var isContainer = false;
	
	if (T.hasClass('row') ||  T.prop('tagName') == "FORM" || T.find('stylearea').length || T.hasClass('blocsapp-device') || T.is('.bloc .container ,.bloc .btn-dropdown, select, .bloc .dropdown') || T.hasClass('carousel') || T.hasClass('carousel-inner') || T.hasClass('carousel-item'))
	{
		isContainer = true;
	}
	else if (T.is('ol') && !T.is('.carousel-indicators'))
	{
		isContainer = true;
	}
	else if (T.hasClass('carousel-caption') && !T.children().hasClass('empty-column'))
	{
		isContainer = true;
	}
	else if (T.hasClass('card') && !T.children().hasClass('empty-column') || T.hasClass('card-header') && !T.children().hasClass('empty-column') || T.hasClass('card-body') && !T.children().hasClass('empty-column') || T.hasClass('card-footer') && !T.children().hasClass('empty-column')) // Cards
	{
		isContainer = true;
	}
	else if (T.prop('tagName') == 'BLOCSCONTAINER' && !T.children().hasClass('empty-column') || T.is('cmsblock, pulsecms') && !T.children().hasClass('empty-column')) // Blocs Container
	{
		isContainer = true;
	}
	else if (T.prop('tagName') == 'BLOCSALERT' && !T.children().hasClass('empty-column')) // Alert Container
	{
		isContainer = true;
	}
	else if (T.prop('tagName') == "PULSECMS" && !T.children().hasClass('empty-column') ||  T.prop('tagName') == "CMSBLOCK" && !T.children().hasClass('empty-column')) // CMS Containers
	{
		isContainer = true;
	}
	else if (T.is('ul') && T.children().length > 0 ) // List
	{
		isContainer = true;
	}
	else if (T.is('ul li, ol li') && !T.children().hasClass('empty-column')) // List Item
	{
		isContainer = true;
	}
	else if (T.is('.row > [class^="col"], .row > [class*=" col"]') && !T.children().hasClass('empty-column')) // Columns
	{
		isContainer = true;
	}	
	else if (T.is('.bloc .btn, .bloc-link, .a-btn') || T.is('.bloc a') && T.closest('h1, h2, h3, h4, h5, h6, p, label, li').length) // Button & Link
	{
		if (T.find('icon, b, i, u, strike, br, span').length)
		{
			if (!T.is('.twitter-share-button')) // Not Twitter Share Button
			{
				isContainer = true;
			}
		}
	}
	else if (T.is('h1,h2,h3,h4,h5,h6,label,p,b,i,u,strike,stylearea,icon')) // Links nested in text
	{
		if (T.children().length > 0)
		{
			isContainer = true;
		}
	}	
	
	return isContainer;
}

// Check Object has Children
function hasChildren(T)
{
	var hasChildren = (T.children().length > 0);
	
	// Bloc children for certain scenarios
	if (T.children().hasClass('empty-column') || T.is('.bloc a') && !T.closest('.bloc .btn, .bloc-link, .a-btn, h1, h2, h3, h4, h5, h6, p, label, li').length || T.is('.form-check, .custom-switch') || T.is('.embed-responsive, audio') || T.is('.divider-h, .divider-v') || T.closest('disqus-comments').length
|| T.closest('custombric').length || T.is('.bloc .carousel-indicators') || T.hasClass('ui-navbar-toggler') || T.is('.blocs-custom-html') || T.is('.video-bg-container') ||  T.is('.twitter-share-button, .bloc-shape-divider'))
	{
		hasChildren = false;
	}
	
	return hasChildren;
}

// If Layer Locked
function isLayerLocked(T)
{
	var isLocked = false;
	
	if (T.is('.bloc .container, .carousel-indicators, .carousel-item > img, .carousel-inner, .carousel-caption, .carousel-control-prev .sr-only, .carousel-control-next .sr-only, .carousel-control-prev, .carousel-control-next, .navbar-brand, .navbar-collapse, .navbar-collapse ul, .navbar-collapse ol, .video-bg-container, .blocsapp-device *, select *, .bloc-shape-divider'))
	{
		isLocked = true;
	}
	else if (T.is('.bloc ul li, .bloc ol li') && T.parent().hasAttr('data-custom-blocs-menu-id') && T.parent().attr('data-custom-blocs-menu-id') != '-1') // Data fed List Items
	{
		isLocked = true;
	}
	else if (T.closest('li').length && T.closest('li').parent().hasAttr('data-custom-blocs-menu-id') && T.closest('li').parent().attr('data-custom-blocs-menu-id') != '-1') // Data fed List Items Children
	{
		isLocked = true;
	}
	else if (T.is('.bloc .btn-group.btn-dropdown .btn, .bloc .btn-group.btn-dropdown ul, .bloc .btn-group.btn-dropdown ol, .btn icon, .btn b, .btn i,.btn u, .btn strike, .bloc-link b, .bloc-link i,.bloc-link u, .bloc-link strike, .bloc .site-navigation .btn-dropdown, .bloc .btn-dropdown .nav-link'))
	{
		isLocked = true;
	}
	else if (T.parent().is('h1,h2,h3,h4,h5,h6,p,label,b,i,u,strike,stylearea')) // Links and Spans nested in text objects
	{
		isLocked = true;
	}
	else if(T.hasClass('ui-navbar-toggler'))
	{
		isLocked = true;
	}

	return isLocked;
}


// Check If Object Is Last Child
function isLastChild(T)
{
	var isLastChild = T.is(':last-child');
	
	if (T.is('.navbar-brand img')) // Logo Image
	{
		isLastChild = T.parent().is(':last-child');
	}
	else if (T.is('br:last-child')) // <br\> is last child tag
	{
		isLastChild = true;
	}
	else if (T.is('h1 a icon, h2 a icon, h3 a icon, h4 a icon, h5 a icon, h6 a icon, p a icon, label a icon')) // Text Icon Links
	{
		if (!T.closest('.bloc a').is(':last-child')) // Link is last not child
		{
			isLastChild = false;
		}
	}
	else if (T.closest('.bloc a').length && !T.closest('.bloc .btn, .bloc-link, h1, h2, h3, h4, h5, h6, p, label').length) // Nested in a link
	{
		if (!T.closest('.bloc a').is(':last-child')) // Parent Link Not Last Child
		{
			isLastChild = false;
		}
	}
	else if (T.is('.bloc .container:last')) // Handle Last Container
	{
		isLastChild = true;
	}

	return isLastChild;
}

 // Select Layer
function selectLayerTreeItem()
{	
	window.webkit.messageHandlers.selectLayer.postMessage(getItemTreeIndex(TIO));
}


// Get Items Tree Index
function getItemTreeIndex(targetObj)
{
	var itemIndexes;
	
	if (targetObj == "Bloc") // Bloc
	{
		var insideGroup = $('#bloc-'+CB).closest('.bloc-group').length;
		itemIndexes = '{\"blocID\":\"'+CB+'\", \"inGroup\":\"'+insideGroup+'\"}';
	}
	else if (targetObj.is('.bloc-group')) // Bloc Group
	{
		var blocID = targetObj.find('.bloc').parent().attr('data-bn');
		itemIndexes = '{\"blocID\":\"'+blocID+'\", \"inGroup\":\"false\", \"isGroup\":\"true\"}';
	}
	else // Bric
	{
		var targetParent = targetObj.parent();
		var indexArray = getLayerIndexPosArray(targetObj);
		var insideGroup = targetObj.closest('.bloc-group').length;
		var blocID = targetObj.closest('.bloc-container').attr('id').replace('b-','');
		itemIndexes = '{\"blocID\":\"'+blocID+'\",  \"inGroup\":\"'+insideGroup+'\", \"index\":\"'+indexArray.join(',')+'\"}';
	}
	
	return itemIndexes;
}

// Get Layer Index Position Array
function getLayerIndexPosArray(targetObj)
{
	var indexArray = [targetObj.index()];
	
	if (targetObj.is('.bloc img, .bloc icon') && targetObj.closest('.bloc a').length && !targetObj.closest('.bloc a.btn').length) // Object is a nested in link so dont use Index
	{
		indexArray = [];
	}
	
	targetObj.parentsUntil('.bloc').each(function() // Loop all parents and get indexes
	{
		if (!$(this).hasClass('empty-column')) // Skip Empty Columns
		{
			var index = $(this).index();
			indexArray.push(index);
		}
	});
	
	return indexArray;
}


// Add Item To Layer Tree
function addItemToLayerTree()
{
	populateLayerTree();
}

// Add Bloc Item To Layer Tree
function addBlocItemToLayerTree(targetObj)
{
	var blocID = targetObj.attr('id'); // Bloc ID
	var blocNumber = targetObj.parent().attr('data-bn'); // Bloc Number
	var isGlobalItem = !targetObj.closest('.page').length;
	var bricID = getObjectAttr(targetObj,'id');
	var blocClasses = getObjectAttr(targetObj,'data-custom-classes');
	var blocIndexPos = 0;
	
	if (targetObj.closest('#pc-nav').length) // Inside Nav
	{
		blocIndexPos = $('#pc-nav > div').index(targetObj.closest('.bloc-container'));
	}
	else if (targetObj.closest('#pc-footer').length) // Inside Footer
	{
		blocIndexPos = $('#pc-footer > div').index(targetObj.closest('.bloc-container'))+$('#pc-'+AP+' > .bloc-container, #pc-'+AP+' .bloc-group').length;
		
		if (!$('#pc-'+AP).hasAttr('hide-nav-area')) // Include Nav Blocs
		{
			blocIndexPos += $('#pc-nav > .bloc-container, #pc-nav .bloc-group').length;
		}
	}
	else // Dynamic Area
	{
		blocIndexPos = $('#pc-'+AP+' > div').index(targetObj.closest('.bloc-container'));
		
		if (!$('#pc-'+AP).hasAttr('hide-nav-area')) // Include Nav Blocs
		{
			blocIndexPos += $('#pc-nav > .bloc-container, #pc-nav .bloc-group').length;
		}
	}

	if(!$(this).hasAttr('id')) // Bloc has no ID use index
	{
		blocID = blocIndexPos;
	}
	
	var blocData = '{\"type\":\"Bloc\", \"tag\":\"Bloc\", \"blocID\":\"'+blocNumber+'\", \"id\":\"'+blocID+'\", \"bricID\":\"'+bricID+'\", \"customClasses\":\"'+blocClasses+'\", \"index\":\"'+blocIndexPos+'\", \"isContainer\":\"true\", \"isGlobal\":\"'+isGlobalItem+'\", \"isLocked\":"false", \"layerColor\":"None", \"children\":['+getItemChildLayerData(targetObj);
	window.webkit.messageHandlers.addBlocLayer.postMessage(blocData);
}

// Is Bloc Global
function isBlocGlobal()
{
	var isGlobalItem = !$("#bloc-"+CB+" div.bloc").closest('.page').length;
	window.webkit.messageHandlers.setGlobalLayer.postMessage(isGlobalItem);
}


// Get Objects Attr
function getObjectAttr(targetObj, attrName)
{
	var targetAttr = '';
	
	if (targetObj.hasAttr(attrName))
	{
		targetAttr = targetObj.attr(attrName);
	}
	
	if (targetAttr.charAt(0) == ' ') // If first char is space
	{
		targetAttr = targetAttr.substring(1);
	}
	
	return targetAttr;
}

// Assign Layer Color
function assignLayerColor(layerColor)
{
	var targetLayer = GTO();
	targetLayer.attr('data-blocsapp-layer-color',layerColor);
}

// Get Layer Name
function getLayerName(targetObject)
{
	var layerName =  targetObject.prop('tagName').toLowerCase(); // Get object name

	if (targetObject.hasClass('container'))
	{
		layerName = "Container";
	}
	else if (targetObject.hasClass('row'))
	{
		layerName = 'Row';
		
		if (targetObject.hasClass('navbar'))
		{
			layerName = 'Nav Bar';
		}
	}
	else if(targetObject.hasClass('btn'))
	{
		layerName = "Button";
	}
	else if(targetObject.hasClass('btn-group') || targetObject.hasClass('btn-dropdown'))
	{
		layerName = "Button Group";
	}
	else if(targetObject.prop('tagName') == "A")
	{
		layerName = "Link";
		
		if (targetObject.find('img').length)
		{
			layerName = "Image";
		}
		else if(targetObject.is('.navbar-brand'))
		{
			layerName = "Logo";
		}
		else if (targetObject.find('icon').length)
		{
			layerName = "Icon";
		}
		else if (targetObject.is('.twitter-share-button'))
		{
			layerName = "Tweet Button";
		}
	}
	else if(targetObject.hasClass('twitter-share-button'))
	{
		layerName = "Tweet Button";
	}
	else if (targetObject.hasClass('form-check'))
	{
		layerName = "Check Box";
		
		if (targetObject.find('input[type="radio"]').length)
		{
			layerName = "Radio";
		}
	}
	else if (targetObject.hasClass('custom-switch'))
	{
		layerName = "Switch";
	}
	else if (targetObject.closest('.carousel').length)
	{
		if (!targetObject.parent().closest('.carousel-caption').length) // Not in carousel caption area
		{
			layerName = "Carousel";
			
			if (targetObject.hasClass('carousel-inner'))
			{
				layerName = "Inner Container";
			}
			else if (targetObject.hasClass('carousel-indicators'))
			{
				layerName = "Carousel Indicators";
			}
			else if (targetObject.hasClass('carousel-item'))
			{
				layerName = "Carousel Item";
			}
			else if (targetObject.prop('tagName') == 'IMG')
			{
				layerName = "Image";
			}
			else if (targetObject.hasClass('carousel-caption'))
			{
				layerName = "Caption Area";
			}
			else if (targetObject.is('.carousel-control-prev .sr-only'))
			{
				layerName = "Previous Button";
			}
			else if (targetObject.is('.carousel-control-next .sr-only'))
			{
				layerName = "Next Button";
			}
			
		}
	}
	else if(targetObject.closest('.divider-h').length || targetObject.closest('.divider-v').length)
	{
		layerName = "Divider";
	}
	else if(targetObject.hasClass('card'))
	{
		layerName = "Card";
		
		if (targetObject.is('[bloc-card-type="modal"]')) // Modal
		{
			layerName = "Modal";
		}
	}
	else if(targetObject.hasClass('card-header'))
	{
		layerName = "Card Header";
		
		if (targetObject.parent().is('[bloc-card-type="modal"]')) // Modal Header
		{
			layerName = "Modal Header";
		}
	}
	else if(targetObject.hasClass('card-body'))
	{
		layerName = "Card Body";
		
		if (targetObject.parent().is('[bloc-card-type="modal"]')) // Modal Body
		{
			layerName = "Modal Body";
		}
	}
	else if(targetObject.hasClass('card-footer'))
	{
		layerName = "Card Footer";
		
		if (targetObject.parent().is('[bloc-card-type="modal"]')) // Modal Body
		{
			layerName = "Modal Footer";
		}
	}
	else if(targetObject.hasClass('ui-navbar-toggler'))
	{
		layerName = "Nav Toggle";
	}
	else if(targetObject.prop('tagName') == "UL" || targetObject.prop('tagName') == "OL" || targetObject.hasClass('site-navigation'))
	{
		layerName = "List";
	}
	else if(targetObject.prop('tagName') == "LI")
	{
		layerName = "List Item";
	}
	else if(targetObject.hasClass('blocs-custom-html'))
	{
		layerName = "Code Widget";
	}
	else if(targetObject.hasClass('embed-responsive'))
	{
		layerName = "Video";
	}
	else if(targetObject.is('audio'))
	{
		layerName = "Audio Player";
	}
	else if(targetObject.hasClass('video-bg-container'))
	{
		layerName = "Video Background";
	}
	else if(targetObject.hasClass('blocsapp-device'))
	{
		layerName = "Device";
		
		if(targetObject.hasClass('blocsapp-device-iphone5') || targetObject.hasClass('blocsapp-device-iphone6') )
		{
			layerName = "Device";
		}
		else if(targetObject.hasClass('blocsapp-device-imac'))
		{
			layerName = "Device";
		}
		else if(targetObject.hasClass('blocsapp-device-mb'))
		{
			layerName = "Device";
		}
		else if(targetObject.hasClass('blocsapp-device-ipad'))
		{
			layerName = "Device";
		}
		else if(targetObject.hasClass('blocsapp-device-watch'))
		{
			layerName = "Device";
		}
	}
	else if(targetObject.prop('tagName') == "PULSECMS" || targetObject.prop('tagName') == "CMSBLOCK")
	{
		layerName = "Pulse CMS Container";
		
		if(targetObject.hasClass('october-cms-block'))
		{
			layerName = "October CMS Container";
		}
	}
	else if(targetObject.prop('tagName') == 'BLOCSALERT')
	{
		layerName = "Alert";
	}
	else if(targetObject.prop('tagName') == 'STYLEAREA')
	{
		layerName = "Span";
	}
	else if(targetObject.prop('tagName') == 'BLOCSCONTAINER')
	{
		layerName = "Div Container";
		
		if (targetObject.hasClass('blockquote')) // Backquote
		{
			layerName +=' : Backquote'
		}
		else if (targetObject.hasClass('form-group')) // Form Group
		{
			layerName +=' : Form Group'
		}
		else if (targetObject.is('[blocs-container-type="Accordion"]')) // Accordion
		{
			layerName +=' : Accordion'
		}
	}
	else if (targetObject.is('.navbar-collapse'))
	{
		layerName = 'Nav Container';
	}
	else if(targetObject.is('.row > [class^="col"], .row > [class*=" col"]'))
	{
		layerName = 'Column';
	}
	else if(targetObject.is('custombric'))
	{
		layerName = targetObject.attr('custom-bric-name');
	}
	else if(targetObject.is('form'))
	{
		layerName = "Form";
	}
	else if(targetObject.is('b'))
	{
		layerName = "Bold Wrapper";
	}
	else if(targetObject.is('i'))
	{
		layerName = "Italic Wrapper";
	}
	else if(targetObject.is('u'))
	{
		layerName = "Underline Wrapper";
	}
	else if(targetObject.is('strike'))
	{
		layerName = "Strikethrough Wrapper";
	}
	else if (targetObject.is('.bloc-shape-divider.bloc-divider-top'))
	{
		layerName = "Top Bloc Edge Divider";
	}
	else if (targetObject.is('.bloc-shape-divider.bloc-divider-bottom'))
	{
		layerName = "Bottom Bloc Edge Divider";
	}
	
	return layerName;
}

// Refresh Layer Tree Item Label Class Data
function refreshLayerTreeItemLabelClassData()
{
	var classTargetItem = GTCO();
		
	if (classTargetItem.hasAttr('data-custom-classes')) // Has Custom Class Data Attribute
	{
		window.webkit.messageHandlers.updateLayerAttr.postMessage('{\"type\":\"class\",\"value\":\"'+classTargetItem.attr('data-custom-classes')+'\"}'); // Update Layer
	}
}

