//*******************************************************************************
// String Helpers
//*******************************************************************************

// Clean Column Class Data
function cleanColumnClassData()
{
	var classData = getObjNoneCustomClasses(TIO); // Get Classes Without Custom Classes
	classData = removeGlobalColorClassFromString(classData); // Remove Global Color Class
    return classData;
}

// Get Object Classes Without Custom Classes
function getObjNoneCustomClasses(T)
{
	var classData = T.attr('class');

	if (T.hasAttr('data-custom-classes')) // Has Custom Classes
	{
		var cleanClassArray = [];
		var classesArray = T.attr('class').split(' ');
		var customClassesArray = T.attr('data-custom-classes').split(' ');

		$.each(classesArray, function(i, className) // Loop All Classes
		{
	        if (className.length) // Class Name Valid
	        {
	        	if ($.inArray(className, customClassesArray) == -1) // Not A Custom Class
				{
					cleanClassArray.push(className);
				}
	        }
	    });

		classData = cleanClassArray.join(' ');
	}

	return classData;
}

// Remove Global Color
function removeGlobalColorClassFromString(classData)
{
	var selectedObjColorVals = setTargetColorOption(); // Create target data array
	var globalClassName = selectedObjColorVals[1]; // Target class name	
	var globalColorClass = GCSC(classData,globalClassName); // Swatch ID
	return classData.replace(globalColorClass,'');
}

// Escape String
function escapeString(stringVal)
{
	stringVal = stringVal.replace(/&/g,'&amp;');
	stringVal = stringVal.replace(/</g,'&lt;');
	stringVal = stringVal.replace(/>/g,'&gt;');

	return stringVal;
}

// Escape String For Json
function escapeStringForJson(stringVal)
{
	if (stringVal)
	{
		stringVal = stringVal.replace(/"/g,'\\"');
	}
	
	return stringVal;
}