//*******************************************************************************
// Page Template Generator
//*******************************************************************************


// Store Classes In Templates
window.templateClassDataArray = [];
window.templateClassTabletDataArray = [];
window.templateClassMobileDataArray = [];
window.templateClassMobileSmallDataArray = [];
window.templateSwatchIdDataArray = [];
window.templateSwatchHexDataArray = [];
window.templateSwatchRGBADataArray = [];
window.templateAssetArray = [];
window.templateGoogleFontArray = [];
window.templateCodeWidgetArray = [];


function getTemplateData(classData,swatchIdArray,swatchHexArray,includeGlobalTop,includeGlobalBottom)
{		
	getTemplateUsedImages(false);
	getTemplateUsedGlobalSwatches(swatchIdArray,swatchHexArray,false);
	getRequiredClassData(classData.split("//**classData**//")); // Populate Required Class Data Arrays
	requiredBGClassData = getBGClassData(false);
	getTemplateUsedFonts(false);
	getTemplateUsedCodeWidgets(false);

	$('#active-object, #hover-object, #add-zone, #resize-handle').remove(); // Hide All App UI
	
	var navHTML = getGlobalAreaData(0,includeGlobalTop);
	var pageHTML = updateAssetPathsInHTML($('#pc-'+AP).html());
	var footHTML = getGlobalAreaData(1,includeGlobalBottom);
   	var templateData = navHTML+'/**TEMPLATE**/'+pageHTML+'/**TEMPLATE**/'+footHTML+'/**TEMPLATE**/'+templateClassDataArray.join('')+'/**TEMPLATE**/'+templateClassTabletDataArray.join('')+'/**TEMPLATE**/'+templateClassMobileDataArray.join('')+'/**TEMPLATE**/'+templateClassMobileSmallDataArray.join('')+'/**TEMPLATE**/'+requiredBGClassData.join('')+'/**TEMPLATE**/'+templateAssetArray+'/**TEMPLATE**/'+templateSwatchIdDataArray+'/**TEMPLATE**/'+templateSwatchHexDataArray+'/**TEMPLATE**/'+templateSwatchRGBADataArray.join('/*,*/')+'/**TEMPLATE**/'+templateGoogleFontArray+'/**TEMPLATE**/'+templateCodeWidgetArray;
	
	AEOM(); // Refresh Active Object
	
	return templateData.toString();
}

// Get Page Classes - Used Before Template Creation
function getPageClasses()
{
	var pageClassArray = [];
	
	$('#pc-nav [data-custom-classes], #pc-'+AP+' [data-custom-classes], #pc-footer [data-custom-classes]').each(function() // Loop All objects on page that have custom classes
	{
		var objClassArray = $(this).attr('data-custom-classes').split(' '); // Create Target Object Array
		
		$.each(objClassArray, function(i, className) // Loop target object classes
		{
			if (className.length) // Check Class Name Valid
			{
				if (pageClassArray.indexOf(className) == -1) // Check class doesnt already exist in storage
				{
					pageClassArray.push(className); // Push Class To Array
				}
			}
		});
	});
	
	return pageClassArray.join(',');
}

// Get Global Area Data - Target (Nav | Footer)
function getGlobalAreaData(T,S)
{
	var areaData = "none";
	
	if (S == 1) // Store Global Area
	{
		if (T == 0) // Nav Global Area
		{
			if ($('#pc-nav .bloc').length)
			{
				areaData = updateAssetPathsInHTML($('#pc-nav').html());
			}
		}
		else // Footer Global Area
		{
			if ($('#pc-footer .bloc').length)
			{
				areaData = updateAssetPathsInHTML($('#pc-footer').html());
			}
		}
	}
	
	return areaData;
}

// Get Template Used Global Swatches
function getTemplateUsedGlobalSwatches(swatchIdArray,swatchHexArray,isBloc)
{
	templateSwatchIdDataArray = []; // Reset Swatch ID Array
	templateSwatchHexDataArray = []; // Reset Swatch Hex Array
	templateSwatchRGBADataArray = []; // Reset Swatch RGBA Array
	
	var idArray = swatchIdArray.split(',').slice(1);
	var hexArray = swatchHexArray.split(',').slice(1);
	var swatchExtArray = [".bgc-",".tc-",".btn-c-",".wire-btn-c-",".ltc-",".icon-"];
	
	$.each(idArray, function(i, swatchID) // Loop Swatch ID's
	{
		var swatchHex = hexArray[i];

		$.each(swatchExtArray, function(i, swatchExt) // Loop through Classes Array
		{
			var swatchClass = swatchExt+swatchID;

			if (isBloc) // Is Bloc
			{
				if ($('#b-'+CB).parent().is('.bloc-group')) // Bloc Group
				{
					if ($('#b-'+CB).parent().find(swatchClass).length) // Found Swatch
					{
						if (templateSwatchIdDataArray.indexOf(swatchID) == -1) // Check ID Doesnt exists in storage
						{
							templateSwatchIdDataArray.push(swatchID); // Store Swatch ID
							templateSwatchHexDataArray.push(swatchHex); // Store Hex data
							templateSwatchRGBADataArray.push(GGSRGBA('bgc-'+swatchID,'background-color').replace(/ /g,'')); // Store RGBA Data
						}
					}
				}
				else // Single Bloc
				{
					if ($('#bloc-'+CB+' '+swatchClass).length) // Found Swatch
					{
						if (templateSwatchIdDataArray.indexOf(swatchID) == -1) // Check ID Doesnt exists in storage
						{
							templateSwatchIdDataArray.push(swatchID); // Store Swatch ID
							templateSwatchHexDataArray.push(swatchHex); // Store Hex data
							templateSwatchRGBADataArray.push(GGSRGBA('bgc-'+swatchID,'background-color').replace(/ /g,'')); // Store RGBA Data
						}
					}
				}
				
			}
			else if ($('#pc-nav '+swatchClass).length || $('#pc-'+AP+' '+swatchClass).length || $('#pc-footer '+swatchClass).length) // Found Swatch for Page
			{
				if (templateSwatchIdDataArray.indexOf(swatchID) == -1) // Check ID Doesnt exists in storage
				{
					templateSwatchIdDataArray.push(swatchID); // Store Swatch ID
					templateSwatchHexDataArray.push(swatchHex); // Store Hex data
					templateSwatchRGBADataArray.push(GGSRGBA('bgc-'+swatchID,'background-color').replace(/ /g,'')); // Store RGBA Data
				}
			}
		});
	});
}




// Update The Asset Tags In Page Template HTML
function updateAssetPathsInHTML(htmlData)
{
	$.each(templateAssetArray, function(i, assetPath) // Loop through Classes Array
	{ 
		var filename = assetPath.substring(assetPath.lastIndexOf("/")+1);
		assetPath = assetPath.replace(/\[/g,'\\['); // esacpe open square braket

		var re = new RegExp(assetPath,"g");
		htmlData = htmlData.replace(re,'<templateAssetPath>'+filename);
	});

	return htmlData;
}


// Get Required Class Data
function getRequiredClassData(classNameArray)
{
	templateClassDataArray = []; // Clear Class Array
	templateClassTabletDataArray = []; // Clear Tablet Class Array
	templateClassMobileDataArray = []; // Clear Mobile Class Array
	templateClassMobileSmallDataArray = []; // Clear Mobile Small Class Array
	
	$.each(classNameArray, function(i, className) // Loop through Classes Array
	{ 		
		if (className.length > 0) // Make Sure Class name Is Valid
		{
			var targetClassName = '.'+className+'{';
			var targetClassNameHover = '.'+className+':hover{';
			var targetClassNameActive = '.'+className+':active{';
			var targetData = '#custom-classes';
			var classesStoredData = $(targetData).html();
			var targetStorageArray = templateClassDataArray;

			for (i = 0; i < 4; i++) // Loop over each class storage (Desktop | Tablet | Mobile | Small Mobile)
			{ 
				if (i == 1) // Tablet
				{
					targetData = '#custom-classes-tablet';
					targetStorageArray = templateClassTabletDataArray; // Set Storage Array
				}
				else if (i == 2) // Mobile
				{
					targetData = '#custom-classes-mob';
					targetStorageArray = templateClassMobileDataArray; // Set Storage Array
				}
				else if (i == 3) // Mobile Small
				{
					targetData = '#custom-classes-mob-small';
					targetStorageArray = templateClassMobileSmallDataArray; // Set Storage Array
				}
			
				classesStoredData = $(targetData).html(); // Get Class Zone Data
	
				for (a = 0; a < 3; a++) // Loop over each class storage (normal | Hover | Active)
				{ 
					var targetSelector = targetClassName;
		
					if (a == 1) // Hover
					{
						targetSelector = targetClassNameHover;
					}
					else if (a == 2) // Active
					{
						targetSelector = targetClassNameActive;
					}
		
					if (classesStoredData.indexOf(targetSelector) !=-1) // Check class exists in storage
					{
						var startPoint = classesStoredData.indexOf(targetSelector);
						var trimmedToStartData = classesStoredData.substring(startPoint);
						var targetClassData = trimmedToStartData.substring(0,trimmedToStartData.indexOf('}')+1);

						targetStorageArray.push(checkClassesForBgImages(targetClassData)); // Push Class Data to array after Checking it for BG Images
					}
				}	// END STATE LOOP
			} // END BREAKPOINT LOOP
		}
	}); // END CLASS NAME LOOP
}

// Get Required BG Class Data
function getBGClassData(isBloc)
{
	var usedBGArray = [];
	var bgClassData = $('#custom-backgrounds').html().replace(/\r?\n|\r/g,'');
	var bgClassDataLive = $('#custom-backgrounds-live').html().replace(/\r?\n|\r/g,'');
	
	var backgroundClassArray = bgClassData.split('}');
	var backgroundClassArrayLive = bgClassDataLive.split('}');
	
	backgroundClassArray.pop();
	backgroundClassArrayLive.pop();

	$.each(backgroundClassArray, function(i, classVal) // Loop through Classes Array
	{
		var liveClassVal = backgroundClassArrayLive[i];
		var className = classVal.substring(0,classVal.indexOf('{'));

		if (isBloc) // Is Bloc template
		{
			if ($('#b-'+CB).parent().is('.bloc-group')) // Bloc Group
			{
				if ($('#b-'+CB).parent().find(className).length) // Check Background Class Usage
				{	
					if (classVal != backgroundClassArrayLive[i]) // Local Bg Class
					{
						classVal = classVal.replace('img/','<templateAssetPath>');
					}
					
					usedBGArray.push(classVal+'}');
				}
			}
			else // Normal Bloc
			{
				if ($('#bloc-'+CB+' '+className).length) // Check Background Class Usage
				{			
					if (classVal != backgroundClassArrayLive[i]) // Local Bg Class
					{
						classVal = classVal.replace('img/','<templateAssetPath>');
					}
					usedBGArray.push(classVal+'}');
				}
			}
		}
		else if ($('#pc-nav '+className).length || $('#pc-'+AP+' '+className).length || $('#pc-footer '+className).length) // Check Background Class Usage (page Template)
		{			
			if (classVal != backgroundClassArrayLive[i]) // Local Bg Class
			{
				classVal = classVal.replace('img/','<templateAssetPath>');
			}
			usedBGArray.push(classVal+'}');
		}
	});

	return usedBGArray;
}



// Inject Page Template Cutsom Classes - (type 0 desktop | 1 Tablet | 2 Mobile)
function injectPageTemplateClasses(classData,type)
{
	if (classData != "") // Has Mobile Classes
	{
		var classDataArray = classData.split('}');
		var className;
		var classValue;
		var startIndex;
		
		if (type == 0) // Normal Classes
		{
			$.each(classDataArray, function(i, classVal) // Loop through Classes Array
			{
				startIndex = getClassStartIndex(classVal);
				className = classVal.substring(startIndex,classVal.indexOf('{'));
				classValue = classVal.substring(classVal.indexOf('{'))+'}';

				if (className.length > 0)
				{
					addFullClass(className,classValue); // Add Custom class
				}
			});
		}
		else if (type == 1) // Tablet Classes
		{
			$.each(classDataArray, function(i, classVal) // Loop through Classes Array
			{
				className = classVal.substring(0,classVal.indexOf('{'));
				classValue = classVal.substring(classVal.indexOf('{'))+'}';
				
				if (className.length > 0)
				{
					addMobileClass(1,className,classValue); // Add Custom class Tablet
					addClassToClassManager(className); // Add Class Name To Class Manager
				}
			});	
		}
		else if (type == 2) // Mobile Classes
		{	
			$.each(classDataArray, function(i, classVal) // Loop through Classes Array
			{
				className = classVal.substring(0,classVal.indexOf('{'));
				classValue = classVal.substring(classVal.indexOf('{'))+'}';
		
				if (className.length > 0)
				{
					addMobileClass(2,className,classValue); // Add Custom class Mobile
					addClassToClassManager(className); // Add Class Name To Class Manager
				}
			});	
		}
		else if (type == 3) // Mobile Small Classes
		{	
			$.each(classDataArray, function(i, classVal) // Loop through Classes Array
			{
				//debug('Add Mobile Class '+classVal)
				className = classVal.substring(0,classVal.indexOf('{'));
				classValue = classVal.substring(classVal.indexOf('{'))+'}';
		
				if (className.length > 0)
				{
					addMobileClass(3,className,classValue); // Add Custom class Mobile
					addClassToClassManager(className); // Add Class Name To Class Manager
				}
			});	
		}
	}
}

// Inject Page Template BG CLasses
function injectPageTemplateBGClasses(BGC,BGCL)
{
	var bgClassArray = BGC.split('}');
	var bgLiveClassArray = BGCL.split('}');
	var currentBGData = $('#custom-backgrounds').html();
	
	$.each(bgClassArray, function(i,classItem) // Loop BG Class Array
	{
		if (classItem.length) // Valid Class
		{
			if (currentBGData.indexOf(classItem) == -1) // Doesn't include BG Class So Add
			{
				// Add Background Classes
				$('#custom-backgrounds').append(classItem+'}'); // Add Background Classes
				$('#custom-backgrounds-live').append(bgLiveClassArray[i]+'}'); // Add Background Classes Live
			}
		}
	});
}

// Get Template Images - (is Bloc)
function getTemplateUsedImages(isBloc)
{	
	templateAssetArray = []; // Reset Asset Array
	
	var basicTarget = $('#pc-nav .bloc img, #pc-'+AP+' .bloc img, #pc-footer .bloc img');
	var lightboxTarget = $('#pc-nav [data-lightbox-app], #pc-'+AP+' [data-lightbox-app], #pc-footer [data-lightbox-app]');
	var srcSetTarget = $('#pc-nav [srcset], #pc-'+AP+' [srcset], #pc-footer [srcset]');
	var bgTarget = $('#pc-nav .bloc, #pc-'+AP+' .bloc, #pc-footer .bloc');
	var vidTarget = $('#pc-nav video, #pc-'+AP+' video, #pc-footer video');
	
	if (isBloc)
	{
		basicTarget = $('#bloc-'+CB+' .bloc img');
		lightboxTarget = $('#bloc-'+CB+' [data-lightbox-app]');
		srcSetTarget = $('#bloc-'+CB+' [srcset]');
		bgTarget = $('#bloc-'+CB+' .bloc');
		vidTarget = $('#bloc-'+CB+' video');
		
		if ($('#b-'+CB).parent().is('.bloc-group')) // Bloc Group
		{
			var blocGroup = $('#b-'+CB).parent();
			basicTarget = blocGroup.find('.bloc img');
			lightboxTarget = blocGroup.find('[data-lightbox-app]');
			srcSetTarget = blocGroup.find('[srcset]');
			bgTarget = blocGroup.find('.bloc');
			vidTarget = blocGroup.find('video');
		}
	}
			
	basicTarget.each(function() // BASIC images
	{	
		if (!$(this).closest('.blocs-custom-html').length) // Avoid Images inside HTML Widget
		{
			var origImagePath = $(this).attr("src") // Original Image Path
			var ISRCD = origImagePath.replace('?timestamp='+$(this).attr("data-ts"),''); // Image SRC data
			
			if (ISRCD.substring(0,4) != 'img/') // Check Image is core image
			{
				if ($.inArray(ISRCD, templateAssetArray) == -1) // Check image doesnt already exist
				{
					templateAssetArray.push(ISRCD);
				}
			}
		}
	});
	
	lightboxTarget.each(function() // LIGHTBOX images
	{	
		var LBCP = $(this).attr("data-lightbox-app"); // Lightbox content Path
		var ISRCD = LBCP.replace('?timestamp='+$(this).attr("data-ts"),''); // Image SRC data

		if (ISRCD.substring(0,4) != 'img/') // Check Image is core image
		{
			if ($.inArray(ISRCD, templateAssetArray) == -1) // Check image doesnt already exist
			{
				templateAssetArray.push(ISRCD);
			}
		}		
	});
	
	srcSetTarget.each(function() // High Res images
	{	
		var image2x = $(this).attr("src-2"); // @2x
		var image3x = $(this).attr("src-3"); // @2x
		
		if (image2x) // Has @2x
		{
			if ($.inArray(image2x, templateAssetArray) == -1) // Check image doesnt already exist
			{
				if (image2x.substring(0,4) != 'http') // Not URL
				{
					if (image2x.substring(0,4) != 'img/') // Check Image is core image
					{
						templateAssetArray.push(image2x);
					}
				}
			}
		}
		if (image3x) // Has @3x
		{
			if ($.inArray(image3x, templateAssetArray) == -1) // Check image doesnt already exist
			{
				if (image3x.substring(0,4) != 'http') // Not URL
				{
					if (image3x.substring(0,4) != 'img/') // Check Image is core image
					{
						templateAssetArray.push(image3x);
					}
				}
			}
		}		
	});
	
	bgTarget.parent().each(function() // BLOC BACKGROUND images
	{
		if ($(this).hasAttr("data-bgi-url"))
		{
			if ($(this).attr("data-bgi-url").length > 0) // Make sure attribute is filled
			{
				if ($(this).attr("data-bgi-url").substring(0,4) != 'img/') // Check Image is core image
				{
					if ($.inArray($(this).attr("data-bgi-url"), templateAssetArray) == -1) // Check image doesnt already exist
					{
						templateAssetArray.push($(this).attr("data-bgi-url")); // Push clean url to array
					}
				}	
			}
		}
	});	
	
	vidTarget.each(function() // VIDEOS
	{	
		var vidPath = $(this).children().attr("src"); // Video SRC url
		
		if ($.inArray(vidPath, templateAssetArray) == -1) // Check video doesnt already exist
		{
			if (vidPath.substring(0,6) != 'video/') // Check Video is core Video
			{
				templateAssetArray.push(vidPath);
			}
		}	
	});
}

// Check Background Classes For BG Images
function checkClassesForBgImages(classData)
{
	if (classData.indexOf('background-image:') !=-1) // Found Background Image Rule
	{
		var classArray = classData.split('background-image:');
		
		$.each(classArray, function(i)
		{
			var targetData = classArray[i]
			if (targetData.indexOf('url(') !=-1) // Has Image Path
			{
				var imageULR = targetData.substring(targetData.indexOf('"')+1,targetData.indexOf('");'));
				var imageFileName = imageULR.substring(imageULR.lastIndexOf('/'));

				templateAssetArray.push(imageULR); // Push Image Array to Used Image Array
				classData = classData.replace(imageULR,'<templateAssetPath>'+imageFileName); // Update Class Rule Data
			}
		});
	}	
	return classData;
}

// Get Template Used Fonts
function getTemplateUsedFonts(isBloc)
{	
	templateGoogleFontArray = []; // Reset Used Font Array
	var targetObj = $('#pc-nav .bloc *, #pc-'+AP+' .bloc *, #pc-footer .bloc *');
	
	if (isBloc)
	{
		targetObj = $('#bloc-'+CB+' .bloc *');
		
		if ($('#b-'+CB).parent().is('.bloc-group')) // Bloc Group
		{
			targetObj = $('#b-'+CB).parent().find('.bloc *');
		}
	}
	
	targetObj.each(function() // Loop All objects in Blocs on page
	{
		var usedFont = $(this).css('font-family'); // Get Used Font
		
		if ($.inArray(usedFont, templateGoogleFontArray) == -1) // Check font doesnt already exist in array
		{
			templateGoogleFontArray.push(usedFont);
		}	
	});
}


// Get Template Used CodeWidgets
function getTemplateUsedCodeWidgets(isBloc)
{	
	templateCodeWidgetArray = []; // Reset Used Font Array
	var targetObj = $('#pc-nav .bloc .blocs-custom-html, #pc-'+AP+' .bloc .blocs-hide-custom-html, #pc-footer .bloc .blocs-hide-custom-html');
	
	if (isBloc)
	{
		targetObj = $('#bloc-'+CB+' .bloc .blocs-hide-custom-html');
		
		if ($('#b-'+CB).parent().is('.bloc-group')) // Bloc Group
		{
			targetObj = $('#b-'+CB).parent().find('.bloc .blocs-hide-custom-html');
		}
	}
	
	targetObj.each(function() // Loop All Code Widgets in Blocs on page
	{
		var widgetID = $(this).attr('data-widget-id'); // Get ID
		if ($.inArray(widgetID, templateCodeWidgetArray) == -1) // Check ID doesnt already exist in array
		{
			templateCodeWidgetArray.push(widgetID);
		}	
	});
}


// Get Class Start Index
function getClassStartIndex(D)
{	
	var index = 0;
	if (D.charAt(0) == '.') // Check First Character Is A DOT
	{
		index = D.indexOf('.')+1;
	}
	return index;
}