
var scrollPos;

// Loading page complete
$(window).on('load', function()
{
	pauseAllHypeTimelines();
	window.onscroll = function() {setHypeSequenceTriggers()};

	$(document).bind('mousewheel MozMousePixelScroll', function(evt)
	{
    	if ($('body').hasClass('hype-scroll-lock')) // Scroll Locked
		{
			if (evt.type == 'mousewheel') // Chrome | Safari
			{
				scrollPos -= evt.originalEvent.wheelDelta;
				$('#output').html('value = '+evt.originalEvent.wheelDelta)
			}
			else if (evt.type == 'MozMousePixelScroll') // Firefox
			{
				scrollPos += (evt.originalEvent.detail);
			}
			
			setHypeSequenceTriggers();
		}
	});
})


// Pause All Hype TimeLines
function pauseAllHypeTimelines()
{
	$('.HYPE_document.hype_play_onscreen, .HYPE_document.hype_play_onscroll, .HYPE_document.hype_play_onscroll_lock').each(function() // Loop Hype Documents
	{
		var hypeDocument = HYPE.documents[$(this).attr('hyp_dn')];
		hypeDocument.pauseTimelineNamed('Main Timeline'); // Pause Timeline
		hypeDocument.goToTimeInTimelineNamed(0, 'Main Timeline'); // Reset Timelines
	});
}

// Set Hype Sequence Triggers
function setHypeSequenceTriggers()
{
	$('.HYPE_document.hype_play_onscreen, .HYPE_document.hype_play_onscroll, .HYPE_document.hype_play_onscroll_lock').each(function() // Loop Hype Documents
	{
		var hypeDocument = HYPE.documents[$(this).attr('hyp_dn')];
		playHypeAnimOnEvent($(this),hypeDocument);
	});
}


// Play Animation on Event
function playHypeAnimOnEvent(targetObj,hypeDocument)
{
	if (!$('body').hasClass('hype-scroll-lock')) scrollPos = $(window).scrollTop(); // Store scroll poition when not in lock mode.

    var a = targetObj.offset().top + targetObj.height();
	var b = scrollPos + $(window).height();

    if (targetObj.hasClass('hype_play_onscreen')) // Play On Screen
	{
		if (a < b) // In View
		{
			if (!targetObj.hasClass('hypeAnimStart'))
			{
				hypeDocument.startTimelineNamed('Main Timeline',''); // Move To Scene		
			}
			targetObj.addClass('hypeAnimStart');
		}
	}
	else if (targetObj.hasClass('hype_play_onscroll')) // Play On Screen
	{
		if (a < b) // In View
		{
			var timeLineLength = hypeDocument.durationForTimelineNamed('Main Timeline');
			var offset = ($(window).height()/timeLineLength);

			if (targetObj.hasClass('hype_pb_fast'))
			{
				offset /= 3;
			}

			var scenePos = (b-a)/offset;
			hypeDocument.goToTimeInTimelineNamed(scenePos, 'Main Timeline'); // Move To Scene	
		}
	}
	else if (targetObj.hasClass('hype_play_onscroll_lock')) // Play On Scroll Lock
	{
		var timeLineLength = hypeDocument.durationForTimelineNamed('Main Timeline');
		var offset = ($(window).height()/timeLineLength);

		if (targetObj.hasClass('hype_pb_fast')) offset /= 3; // Play Anim Faster

		if (a < b) // In View
		{
			if (targetObj.hasClass('hype_anim_started_reverse'))
			{
				$('body').removeClass('hype-scroll-lock');
				targetObj.removeClass('hype_anim_started_reverse').addClass('hype_anim_complete');
			}

			if ($('body').hasClass('hype-scroll-lock')) // Lock Mode
			{
				var scenePos = (b-a)/offset;

				if (!targetObj.hasClass('hype_anim_complete'))
				{
					hypeDocument.goToTimeInTimelineNamed(scenePos, 'Main Timeline'); // Move To Scene
				}

				if (scenePos > timeLineLength) // Animation End
				{
					$('body').removeClass('hype-scroll-lock');
					targetObj.addClass('hype_anim_complete').removeClass('hype_anim_started');
				}				
			}
			else // Not Complete Lock
			{
				if (!targetObj.hasClass('hype_anim_complete'))
				{
					$('body').addClass('hype-scroll-lock');
					targetObj.addClass('hype_anim_started').removeClass('hype_anim_complete');
				}
			}
		}
		else // Out of View
		{
			if (targetObj.hasClass('hype_anim_complete'))
			{
				$('body').addClass('hype-scroll-lock');
				targetObj.addClass('hype_anim_started_reverse').removeClass('hype_anim_complete');
			}
			else if (targetObj.hasClass('hype_anim_started')) // Reverse without complete
			{
				$('body').removeClass('hype-scroll-lock');
				targetObj.removeClass('hype_anim_started');
			}
					
			if ($('body').hasClass('hype-scroll-lock')) // In lock Mode
			{
				var scenePos = ((b-a)/offset)+timeLineLength;

				if (scenePos > 0)
				{
					hypeDocument.goToTimeInTimelineNamed(scenePos, 'Main Timeline'); // Move To Scene
				}
				else if (scenePos < 0)
				{
					$('body').removeClass('hype-scroll-lock');
				}
			}
			else if (!targetObj.hasClass('hype_anim_complete'))
			{
				targetObj.removeClass('hype_anim_started_reverse');
			}
		}		
	}
}