//*******************************************************************************
// Icon Font Manager
//*******************************************************************************

var searchVal = '';

$(document).ready(function()
{		
	$('body').on('contextmenu', function(){
	 	//return false;
	});
	
	// Set up tabs navigation
	$('#icon-list').on('click','li', function(e)
	{
		$('.active').removeClass('active');
		$($(this).find('a').attr('href')).addClass('active');
		$(this).addClass('active');
		
		if (searchVal != "")
		{
			filterIcons(searchVal);
		}
		else
		{
			$(".active .icon-tab").show(); // Show all 
		}
	});
	
	// Update icon 
	$('#iconFontManager').on("click",'.icon-tab icon',function()
	{ 
		var V = $(this).attr('class');
		setActiveIcon(V);
		window.webkit.messageHandlers.select.postMessage(V); // Trigger cocoa Select icon
	});
});


function getKeywordsData()
{
	var keywordDataArray = [];
	$('.active .icon-tab').each(function() // Loop icons tabs
	{
		var keywords = $(this).attr('data-keywords').replace(/,/g,'/**/');
		keywordDataArray.push(keywords);
	});
	
	return keywordDataArray.toString();
}


function getClassData()
{
	var classDataArray = [];
	$('.active .icon-tab').each(function() // Loop icons tabs
	{
		var classData = $(this).find('icon').attr('class');
		classDataArray.push(classData);
	});
	
	return classDataArray.toString();
}

// Set Active Icon
function setActiveIcon(classData)
{
	$('.selected').removeClass('selected'); // Clear Selected
	var targetTab = $('[class="'+classData+'"]').parent();
	targetTab.addClass('selected');// Set As Selected
	
	// Set Selected Icon Set
	$('.used-set').removeClass('used-set');
	var collectionID = targetTab.closest('.tab-pane').attr('id');
	$('a[href="#'+collectionID+'"]').parent().addClass('used-set');
}

//*******************************************************************************
//  Populate Icon Sets
//*******************************************************************************


// Add new icon tab
function addNewIconItem(d)
{
	$("#icon-list").append(d);
}

// Add New Icon Set Tab
function addNewIconSetTab(d)
{
	$("#icon-content").append(d+'<div style="clear: both;"></div>');		
}

// Add icon set stylesheet
function addIconStyleSheet(d)
{
	var $ = document;
	var cssId = 'myCss';
	if (!$.getElementById(cssId))
	{
	    var head  = $.getElementsByTagName('head')[0];
	    var link  = $.createElement('link');
	    link.rel  = 'stylesheet';
	    link.type = 'text/css';
	    link.href = d
	    head.appendChild(link);
	}
}

// Set icon tab active
function setActiveTab()
{
	$('#icon-list li:first').addClass('active');
	$('#icon-content .tab-pane:first').addClass('active');	
}


//*******************************************************************************
//   Filter Icons In Search
//*******************************************************************************


function filterIcons(searchString)
{
	searchVal = searchString;
	$(".active .icon-tab").hide(); // Hide all icons

	$('.active .icon-tab').each(function() // Loop icons tabs
	{
		if(searchString != "") // Search field blank so show all icons
		{
			if ($(this).attr("data-keywords").indexOf(searchString.toLowerCase()) != -1) // Get positive icon results
			{
				$(this).show(); // Show qualifying
			}
		}
		else
		{
			$(".active .icon-tab").show(); // Show all 
		}
	});
}



