//*******************************************************************************
// Writer Mode
//*******************************************************************************


// Set Up
$(document).ready(function()
{
	setUpEditArea();
});


// Set Up Edit Area Evenets
function setUpEditArea()
{
	window.webkit.messageHandlers.debug.postMessage('set up text area');

	// Listen for content editable activate
	$('body').on('active', '[contenteditable]', function()
	{
	    
	}
	).on('keydown','[contenteditable]',function(e) // Key Down
	{	
	    if (e.keyCode === 13) // Handle RETURN - Prevent Extra Divs
		{
			var docFragment = document.createDocumentFragment();

			// add the br, or p, or something else
			var newEle = document.createElement('br');
			docFragment.appendChild(newEle);

			// make the br replace selection
			var range = window.getSelection().getRangeAt(0);
			range.deleteContents();
			range.insertNode(docFragment);

			// create a new range
			range = document.createRange();
			range.setStartAfter(newEle);
			range.collapse(true);

			// make the cursor there
			var sel = window.getSelection();
			sel.removeAllRanges();
			sel.addRange(range);
	      	return false;
	    }
		else if (e.keyCode === 8) // Handle DELETE
		{
  		 	AEOM(); // Update edit marker
		}
		else if (e.keyCode === 32) // Space
		{
			SDCS('Typing'); // Save document current state
		}
		else if (e.keyCode === 27) // Esc
		{
			window.webkit.messageHandlers.close.postMessage('');
		}	
	}
	).on('keyup','[contenteditable]',function(e) // Edit
	{
		window.webkit.messageHandlers.change.postMessage($(this).html());
	}
	).on('paste','[contenteditable]',function(e) // Force pasted rich text to be plain in content editabel
	{
	    e.preventDefault();
		var text = ''; // Clear last paste
		text = $('<div></div>').text(e.originalEvent.clipboardData.getData('text'));

		if (document.queryCommandSupported('insertText'))
		{
			document.execCommand('insertHTML', false, $(text).html().replace(/\n/g,'<br>').replace(/\t/g,' ').replace(/[\x00-\x1F]/g, '')); // Remove unprintable characters and replace tabs old version .replace(/[^ -~]/g, '')
		}

		window.webkit.messageHandlers.change.postMessage($(this).html());
	}
	).on('blur', '[contenteditable]', function() // Lose Focus
	{
		window.webkit.messageHandlers.change.postMessage($(this).html());
	});
}


// Set Content
function setContent(content)
{
	var currentContent = $('.writer-mode-text-content-container').html();

	if (currentContent != content)
	{
		$('.writer-mode-text-content-container').html(content);
	}
	
	$('.writer-mode-text-content-container').focus();
}








